Option Explicit
const HexFileName = "..\..\..\Firmware\Blink\Blink.hex"

Dim oDevices
Dim oDevice
Set oDevices = WScript.CreateObject("TBK.SmartICE04.Devices", "Devices_")

If(IsCScript()) Then
   If oDevices.Count Then
      Set oDevice = oDevices(0)
      Devices_OnDeviceAttached oDevices, oDevice
   End If

   CreateObject("WScript.Shell").Popup "Please connect your targets one after another. Close this message not till your done."
Else
   CreateObject("WScript.Shell").Run("cscript.exe //Nologo """ + WScript.ScriptFullName + """")
End If

Function IsCScript()
   IsCScript = (0 < InStr(UCase(WScript.FullName), "CSCRIPT.EXE"))
End Function

Sub Devices_OnDeviceAttached(sender, device)
   Set oDevice = device
   WScript.ConnectObject oDevice, "Device_"
   WScript.Echo "Device " & device.SerialNumber & " attached, Chip = " & Hex(device.ChipId) & ", Version = " & device.ChipVersion
End Sub

Sub Devices_OnDeviceDetached(sender, device)
   WScript.Echo "Device " & device.SerialNumber & " detached."
End Sub

Sub Device_OnTargetVoltageChanged(sender, detected)
   If detected = False Then
      WScript.Echo "Target Voltage removed from SmartICE04 with serial number " & oDevice.SerialNumber
   Else
      WScript.Echo oDevice.TargetVoltage & " mV applied to target at SmartICE04 with serial number " & oDevice.SerialNumber
   End If
End Sub

Sub Device_OnTargetChanged(sender, chipid)
   If chipid = 0 Then
      WScript.Echo "Target Chip detached from SmartICE04 with serial number " & oDevice.SerialNumber
   Else
      WScript.Echo "Chip with Id = " & Hex(chipid) & " attached to SmartICE04 with serial number " & oDevice.SerialNumber

      Dim oProgressDialog
      Set oProgressDialog = CreateObject("TBK.SmartICE04.ProgressDialog")

      oProgressDialog.Title = "SmartICE04 Demo"
      oProgressDialog.Line1 = "Loading HEX file..."
      oProgressDialog.Line2 = ""

      oDevice.EnterDebugMode True
      oDevice.ChipErase
      oDevice.DownloadFile HexFileName, , True, oProgressDialog.Create
      oDevice.EnterDebugMode False
      WScript.Echo "Device programmed successfully."
   End If
End Sub
