#include "precomp.h"

static void USB_Init(void)
{
   POLL_WRITE_BYTE (POWER, 0x08);      // Force Asynchronous USB Reset
   POLL_WRITE_BYTE (IN1IE, 0x03);      // Enable Endpoint 0-1 in interrupts
   POLL_WRITE_BYTE (OUT1IE,0x05);      // Enable Endpoint 0-1 out interrupts
   POLL_WRITE_BYTE (CMIE, 0x07);       // Enable Reset, Resume, and Suspend
                                       // interrupts
   USB0XCN = 0xE0;                     // Enable transceiver; select full speed
   POLL_WRITE_BYTE (CLKREC,0x89);      // Enable clock recovery, single-step
                                       // mode disabled

   EIE1 |= 0x02;                       // Enable USB0 Interrupts

                                       // Enable USB0 by clearing the USB
   POLL_WRITE_BYTE (POWER, 0x01);      // Inhibit Bit and enable suspend
                                       // detection
}

int main(void)
{
    Init_Device();
    Setup_IN_BUFFER();
    USB_Init();
    EA = 1;
    DbgItf_Initialize();
    DbgItf_SetSpeed(DBGITF_SPEED_FAST);

    for(;;)
    {
        if(g_memInfo.blRead)
        {
            if(!g_memInfo.uLen)
            {
                g_memInfo.blRead = FALSE;
                continue;
            }
            SendPacket(4);
        }
        else
        {
            SendPacket(1);
            PCON |= 0x01;
        }
    }

    return 0;
}
