#ifndef MEMORY_H
#define MEMORY_H

enum MemorySegment
{
    segCode = 0,
    segData = 1,
    segXData = 2,
    segIData = 3
};

void Memory_ReadData(unsigned char address, unsigned char len, unsigned char* pBuffer);
void Memory_ReadIData(unsigned char address, unsigned char len, unsigned char* pBuffer);
void Memory_ReadCode(unsigned long address, unsigned char len, unsigned char* pBuffer);
void Memory_ReadXData(unsigned short address, unsigned char len, unsigned char* pBuffer);

void Memory_WriteData(unsigned char address, unsigned char len, const unsigned char* pBuffer);
void Memory_WriteIData(unsigned char address, unsigned char len, const unsigned char* pBuffer);
void Memory_WriteCode(unsigned long address, unsigned char len, const unsigned char* pBuffer);
void Memory_WriteXData(unsigned short address, unsigned char len, const unsigned char* pBuffer);

BOOL Memory_WriteLockBits(const BYTE* pLockBits);
BOOL Memory_ReadLockBits(BYTE* pLockBits);

BOOL Memory_Preserve(void);
void Memory_Restore(void);

#endif
