#ifndef TYPES_H
#define TYPES_H

#define LOBYTE(val)     ((unsigned char)(val))
#define HIBYTE(val)     ((unsigned char)((val) >> 8))
#define LOWORD(val)     ((unsigned int)(val))
#define HIWORD(val)     ((unsigned int)(((val) >> 16)))

#define MAKEWORD(l, h)  ((unsigned int)(BYTE)(l) | (unsigned int)((BYTE)(h)) << 8)
#define MAKEDWORD(l, h) ((DWORD)(unsigned int)(l) | (DWORD)((unsigned int)(h)) << 16)

//#define CHANGE_ENDIANESS(val)       MAKEWORD(HIBYTE(val), LOBYTE(val))
//#define CHANGE_ENDIANESS_DWORD(val) MAKEDWORD(CHANGE_ENDIANESS(HIWORD(val)), CHANGE_ENDIANESS(LOWORD(val)))

// Convert Value from little endian to implementation defined endianess
// and vice versa
#ifdef __IAR_SYSTEMS_ICC__
  #define LENDIAN_TO_IMPL(val)          (val)
  #define IMPL_TO_LENDIAN(val)          (val)
#else
  #define LENDIAN_TO_IMPL(val)          MAKEWORD(HIBYTE(val), LOBYTE(val))
  #define IMPL_TO_LENDIAN(val)          MAKEWORD(HIBYTE(val), LOBYTE(val))
#endif

typedef unsigned char BYTE;
//    typedef unsigned int  WORD;
typedef unsigned long DWORD;

#ifdef __IAR_SYSTEMS_ICC__
  typedef BYTE BOOL;
#else
  typedef bit BOOL;
#endif

#ifndef TRUE
  #define TRUE          1
#endif

#ifndef FALSE
  #define FALSE         0
#endif

#endif
