#include "precomp.h"

CActCtx::CActCtx(UINT idResource)
    : m_hctx(INVALID_HANDLE_VALUE), m_Cookie(0)
{
    ACTCTX ctx;
    TCHAR szSource[MAX_PATH * 2];

    if(GetModuleFileName(g_hInst, szSource, _countof(szSource)))
    {
        ZeroMemory(&ctx, sizeof(ctx));
        ctx.cbSize = sizeof(ctx);
        ctx.dwFlags = ACTCTX_FLAG_RESOURCE_NAME_VALID;
        ctx.lpSource = szSource;
        ctx.lpResourceName = MAKEINTRESOURCE(idResource);
        ctx.hModule = g_hInst; // <-- Does not work on XP, even with ACTCTX_FLAG_HMODULE_VALID set, use lpSource instead

        if(INVALID_HANDLE_VALUE != (m_hctx = CreateActCtx(&ctx)))
            ActivateActCtx(m_hctx, &m_Cookie);
            
    }
}

CActCtx::~CActCtx()
{
    if(m_hctx != INVALID_HANDLE_VALUE)
    {
        if(m_Cookie)
            DeactivateActCtx(0, m_Cookie);

        ReleaseActCtx(m_hctx);
    }
}