#ifndef CCLASSFACTORY_H
#define CCLASSFACTORY_H

class DECLSPEC_NOVTABLE CClassFactory : public IClassFactory
{
public:
    // IUnknown
    STDMETHOD(QueryInterface) (THIS_ REFIID riid, void** ppvObject);
    STDMETHOD_(ULONG, AddRef) (THIS);
    STDMETHOD_(ULONG, Release)(THIS);

    // IClassFactory
    STDMETHOD(LockServer)(THIS_ BOOL fLock);

    CClassFactory() throw();

protected:
    virtual ~CClassFactory() throw();

private:
    ULONG m_lRefCount;
#ifdef _WIN64
    BYTE bPadding[4]; // C4820
#endif
};

template<typename T>
class CClassFactoryT : public CClassFactory
{
public:
    // IClassFactory
    STDMETHOD(CreateInstance)(THIS_ IUnknown* pUnkOuter, REFIID riid, void** ppvObject)
    {
        HRESULT hr = S_OK;
        T*      pcls;

        if(IsBadWritePtrAuto(ppvObject))
            return(E_POINTER);

        *ppvObject = NULL;

        if(pUnkOuter)
            return(CLASS_E_NOAGGREGATION);

        if(NULL == (pcls = new (std::nothrow) T(&hr)))
            return(E_OUTOFMEMORY);

        if(SUCCEEDED(hr))
            hr = pcls->QueryInterface(riid, ppvObject);

        pcls->Release();
        return(hr);
    }
};

#endif
