#ifndef CCONNECTIONPOINT_H
#define CCONNECTIONPOINT_H

class DECLSPEC_NOVTABLE CConnectionPoint : public IConnectionPoint
{
public:
    inline IUnknown* GetUnknown() throw() { return(static_cast<IConnectionPoint*>(this)); }

    // IUnknown
    STDMETHOD(QueryInterface) (THIS_ REFIID riid, void** ppvObject);
    STDMETHOD_(ULONG, AddRef) (THIS);
    STDMETHOD_(ULONG, Release)(THIS);

    // IConnectionPoint
    STDMETHOD(GetConnectionPointContainer)(THIS_ IConnectionPointContainer** ppCPC);
    STDMETHOD(Advise)(THIS_ IUnknown* pUnk, DWORD* pdwCookie);
    STDMETHOD(Unadvise)(THIS_ DWORD dwCookie);
    STDMETHOD(EnumConnections)(THIS_ IEnumConnections** ppEnum);

    __checkReturn HRESULT GetConnectData(__in UINT_PTR uIndex, __out CONNECTDATA* pData) throw();
    FORCEINLINE void SetContainer(IConnectionPointContainer* pCPC) throw() { m_pCPC = pCPC; }

    CConnectionPoint() throw();
    virtual ~CConnectionPoint() throw();

protected:
    CList<CONNECTDATA> m_Connections;
    static HRESULT TryConnect(IUnknown* pUnk, REFIID riid, void** ppvObject) throw();
    IConnectionPointContainer* m_pCPC;

private:
    CConnectionPoint(const CConnectionPoint&);
    CConnectionPoint& operator=(const CConnectionPoint&);
};

#endif
