#include "precomp.h"

STDMETHODIMP
CDSmartICE04DevicesEvents::GetConnectionInterface(IID* pIID)
{
    if(IsBadWritePtrAuto(pIID))
        return(E_POINTER);

    *pIID = DIID__DISmartICE04DevicesEvents;
    return(S_OK);
}

void
CDSmartICE04DevicesEvents::FireEvent(DISPID dispidEvt, IDispatch* TAG)
{
    CONNECTDATA cd;
    DISPPARAMS  DispParams;
    VARIANT     var[2];
    UINT        x;

    VariantInit(&var[0]);
    VariantInit(&var[1]);
    V_DISPATCH(&var[0]) = TAG;
    V_DISPATCH(&var[0])->AddRef();
    V_VT(&var[0]) = VT_DISPATCH;
    m_pCPC->QueryInterface(IID_IDispatch, (void**)&V_DISPATCH(&var[1]));
    V_VT(&var[1]) = VT_DISPATCH;

    DispParams.rgvarg               = var;
    DispParams.rgdispidNamedArgs    = NULL;
    DispParams.cArgs                = _countof(var);
    DispParams.cNamedArgs           = 0;

    for(x = 0; m_Connections.Get(x, &cd); ++x)
        static_cast<IDispatch*>(cd.pUnk)->Invoke(dispidEvt, IID_NULL, CThreadLocale::getLCID(), DISPATCH_METHOD, &DispParams, NULL, NULL, NULL);

    VariantClear(&var[0]);
    VariantClear(&var[1]);
}
