#include "precomp.h"

STDMETHODIMP
CDSmartICE04Events::GetConnectionInterface(IID* pIID)
{
    if(IsBadWritePtrAuto(pIID))
        return(E_POINTER);

    *pIID = DIID__DISmartICE04Events;
    return(S_OK);
}

void
CDSmartICE04Events::FireEvent(DISPID dispidEvt, const VARIANT* param) const
{
    CONNECTDATA cd;
    DISPPARAMS  DispParams;
    VARIANT     var[2];
    UINT        x;

    VariantInit(&var[1]);
    var[0] = *param;
    m_pCPC->QueryInterface(IID_IDispatch, (void**)&V_DISPATCH(&var[1]));
    V_VT(&var[1]) = VT_DISPATCH;

    DispParams.rgvarg               = var;
    DispParams.rgdispidNamedArgs    = NULL;
    DispParams.cArgs                = _countof(var);
    DispParams.cNamedArgs           = 0;

    for(x = 0; m_Connections.Get(x, &cd); ++x)
        static_cast<IDispatch*>(cd.pUnk)->Invoke(dispidEvt, IID_NULL, CThreadLocale::getLCID(), DISPATCH_METHOD, &DispParams, NULL, NULL, NULL);

    VariantClear(&var[1]);
}
