#ifndef CENUMCONNECTIONPOINT_H
#define CENUMCONNECTIONPOINT_H

class CEnumConnectionPoints : public IEnumConnectionPoints
{
public:
    //IUnknown
    STDMETHOD(QueryInterface) (THIS_ REFIID riid, void** ppvObject);
    STDMETHOD_(ULONG, AddRef) (THIS);
    STDMETHOD_(ULONG, Release)(THIS);

    STDMETHOD(Next)(THIS_ ULONG cConnections, IConnectionPoint** ppCP, ULONG* pcFetched);
    STDMETHOD(Skip)(THIS_ ULONG cConnections);
    STDMETHOD(Reset)(THIS);
    STDMETHOD(Clone)(THIS_ IEnumConnectionPoints** ppEnum);

    __checkReturn HRESULT Add(__in IUnknown* pUnknown) throw();

    CEnumConnectionPoints() throw();

private:
    virtual ~CEnumConnectionPoints() throw();
    CEnumConnectionPoints(const CEnumConnectionPoints&);
    CEnumConnectionPoints& operator=(const CEnumConnectionPoints&);

    CList<IConnectionPoint*>  m_list;
    volatile ULONG_PTR        m_lCursor;
    ULONG                     m_lRefCount;
#ifdef _WIN64
    BYTE bPadding[4]; // C4820
#endif
};

#endif