#ifndef CINTELHEXFILE_H
#define CINTELHEXFILE_H

class CIntelHexFile
{
public:
    enum RecordType
    {
        Data = 0,
        EndOfFile = 1,
        ExtendedSegmentAddress = 2,
        StartSegmentAddress = 3,
        ExtendedLinearAddress = 4,
        StartLinearAddress = 5
    };

    static HRESULT Load(LPCWSTR filename, SAFEARRAY** ppsa);

private:
#pragma warning(push)
#pragma warning(disable: 4820)
    struct RECORD_INFO
    {
        RecordType typ;
        unsigned len;
        unsigned offset;
    };
#pragma warning(pop)

    static HRESULT GetRecordInfo(const char* line, RECORD_INFO* pri);
    static HRESULT RecreateArray(long lStartAddress, const RECORD_INFO* pri, SAFEARRAY** ppsa, SAFEARRAYBOUND* psab, BYTE** ppData);
};

#endif