#ifndef CSMARTICE04DEVICES_H
#define CSMARTICE04DEVICES_H

class CSmartICE04Devices : public ISmartICE04Devices, public IConnectionPointContainer, public IProvideClassInfo2, public ISupportErrorInfo
{
protected:
    inline IUnknown* GetUnknown() throw() { return(static_cast<ISmartICE04Devices*>(this)); }
    inline HRESULT RaiseCOMException(DISPID dispid, HRESULT hr) throw() { return(::RaiseCOMException(this, dispid, hr)); }

public:
    // IUnknown
    STDMETHOD(QueryInterface) (THIS_ REFIID riid, void** ppvObject);
    STDMETHOD_(ULONG, AddRef) (THIS);
    STDMETHOD_(ULONG, Release)(THIS);

    // IDispatch
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT* pctinfo);
    STDMETHOD(GetTypeInfo)(THIS_ UINT iTInfo, LCID lcid, ITypeInfo** ppTInfo);
    STDMETHOD(GetIDsOfNames)(THIS_ REFIID riid, LPOLESTR* rgszNames, UINT cNames, LCID lcid, DISPID* rgDispId);
    STDMETHOD(Invoke)(THIS_ DISPID dispIdMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult, EXCEPINFO* pExcepInfo, UINT* puArgErr);

    // ISmartICE04Devices
    STDMETHOD(get_Item)(THIS_ const VARIANT varIndex, VARIANT* pVal);
    STDMETHOD(get_Count)(THIS_ long* pVal);
    STDMETHOD(get_length)(THIS_ long* pVal);
    STDMETHOD(get__NewEnum)(THIS_ IUnknown** ppVal);

    // IConnectionPointContainer
    STDMETHOD(EnumConnectionPoints)(THIS_ IEnumConnectionPoints** ppEnum);
    STDMETHOD(FindConnectionPoint)(THIS_ REFIID riid, IConnectionPoint** ppCP);

    // IProvideClassInfo2
    STDMETHOD(GetClassInfo)(THIS_ ITypeInfo** ppTI);
    STDMETHOD(GetGUID)(THIS_ DWORD dwGuidKind, GUID* pGUID);

    // ISupportErrorInfo
    STDMETHOD(InterfaceSupportsErrorInfo)(THIS_ REFIID riid);

    CSmartICE04Devices(HRESULT* phr) throw();

private:
    virtual ~CSmartICE04Devices();

    CSmartICE04Devices(const CSmartICE04Devices&);
    CSmartICE04Devices& operator=(const CSmartICE04Devices);

    HRESULT Add(LPCTSTR pszName) throw();
    HRESULT Add(const DEV_BROADCAST_DEVICEINTERFACE* pItf) throw();
    HRESULT Remove(LPCTSTR pszName) throw();
    HRESULT Remove(const DEV_BROADCAST_DEVICEINTERFACE* pItf) throw();
    HRESULT getCount(long* pVal) const throw();
    void Refresh(void) throw();

    static LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) throw();

private:
    CList<class CSmartICE04*>   m_Devices;
    CDSmartICE04DevicesEvents   m_DispEvents;
    CSmartICE04DevicesEvents    m_Events;
    HDEVNOTIFY                  m_hDevNotify;
    ITypeInfo*                  m_pTypeInfo;
    HWND                        m_hWnd;
    ULONG                       m_lRefCount;
    BOOL                        m_blRefreshing;
};

#endif