#include "precomp.h"

STDMETHODIMP
CSmartICE04DevicesEvents::GetConnectionInterface(IID* pIID)
{
    if(IsBadWritePtrAuto(pIID))
        return(E_POINTER);

    *pIID = IID_ISmartICE04DevicesEvents;
    return(S_OK);
}

void
CSmartICE04DevicesEvents::FireEvent(DISPID dispidEvt, IDispatch* TAG)
{
    CONNECTDATA cd;
    IDispatch*  pSender = NULL;

    m_pCPC->QueryInterface(IID_IDispatch, (void**)&pSender);

    for(UINT x = 0; m_Connections.Get(x, &cd); ++x)
    {
        switch(dispidEvt)
        {
            case DISPID_SMARTICE04_ONDEVICEATTACHED:
                static_cast<ISmartICE04DevicesEvents*>(cd.pUnk)->OnDeviceAttached(pSender, TAG);
                break;
            case DISPID_SMARTICE04_ONDEVICEDETACHED:
                static_cast<ISmartICE04DevicesEvents*>(cd.pUnk)->OnDeviceDetached(pSender, TAG);
                break;
            default:
#if defined(_MSC_VER) && !defined(_DEBUG)
                __assume(0);
#else
#pragma warning(suppress: 4365)
                assert(!"Unhandled case in switch");
                break;
#endif
        }
    }
    
    if(pSender)
        pSender->Release();
}