#ifndef CSMARTICE04DEVICESEVENTSSINK_H
#define CSMARTICE04DEVICESEVENTSSINK_H

class CSmartICE04DevicesEventsSink : public ISmartICE04DevicesEvents
{
public:
    STDMETHOD(QueryInterface) (REFIID riid, void** ppvObject);
    STDMETHOD_(ULONG, AddRef) ();
    STDMETHOD_(ULONG, Release)();

    STDMETHOD(OnDeviceAttached)(IDispatch* sender, IDispatch* device);
    STDMETHOD(OnDeviceDetached)(IDispatch* sender, IDispatch* device);

    HRESULT Connect();
    HRESULT Disconnect();
    HRESULT EnumDevices();

protected:
    IUnknown* GetUnknown() { return(static_cast<IUnknown*>(this)); }

    virtual void AddDevice(ISmartICE04* pDevice) = 0;
    virtual void RemoveDevice(ISmartICE04* pDevice) = 0;

    CSmartICE04DevicesEventsSink();
    virtual ~CSmartICE04DevicesEventsSink();

private:
    IConnectionPoint*   m_pCP;
    DWORD               m_dwCookie;
#ifdef _WIN64
    BYTE bPadding[4]; // C4820
#endif
};

template<typename T>
class CSmartICE04DevicesEventsSinkT : public CSmartICE04DevicesEventsSink
{
protected:
    virtual void AddDevice(ISmartICE04* pDevice)    { m_pParent->AddDevice(pDevice);    }
    virtual void RemoveDevice(ISmartICE04* pDevice) { m_pParent->RemoveDevice(pDevice); }

public:
    void SetParent(T* pParent) { m_pParent = pParent; }

private:
    T* m_pParent;
};

#endif