#ifndef CSMARTICE04EVENTSSINK_H
#define CSMARTICE04EVENTSSINK_H

class CSmartICE04EventsSink : public ISmartICE04Events
{
protected:
    IUnknown* GetUnknown() { return(static_cast<IUnknown*>(this)); }

public:
    STDMETHOD(QueryInterface)(REFIID riid, void** ppvObject);
    STDMETHOD_(ULONG, AddRef)();
    STDMETHOD_(ULONG, Release)();

    STDMETHOD(OnTargetVoltageChanged)(IDispatch* sender, VARIANT_BOOL volatgeDetected);
    STDMETHOD(OnTargetChanged)(IDispatch* sender, enum ChipId chipId);
    STDMETHOD(OnDebugModeChanged)(IDispatch* sender, VARIANT_BOOL isInDebgMode);

    HRESULT ConnectTo(IUnknown* pUnk);
    HRESULT Disconnect();

    CSmartICE04EventsSink(CDeviceList* pDevList);

private:
    virtual ~CSmartICE04EventsSink();

    CDeviceList* m_pDevList;
    IConnectionPoint* m_pCP;
    DWORD m_dwCookie;
#ifdef _WIN64
    BYTE bPadding[4]; // C4820
#endif
};

#endif