#ifndef CSMARTICE04PROGRESS_H
#define CSMARTICE04PROGRESS_H

class CSmartICE04Progress : public IDispatch, public ISmartICE04Progress, public ISupportErrorInfo
{
protected:
    inline IUnknown* GetUnknown() { return(static_cast<IDispatch*>(this)); }
    inline HRESULT RaiseCOMException(DISPID dispid, HRESULT hr) { return(::RaiseCOMException(this, dispid,hr)); }

public:
    // IUnknown
    STDMETHOD(QueryInterface) (THIS_ REFIID riid, void** ppvObject);
    STDMETHOD_(ULONG, AddRef) (THIS);
    STDMETHOD_(ULONG, Release)(THIS);

    // IDispatch
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT* pctinfo);
    STDMETHOD(GetTypeInfo)(THIS_ UINT iTInfo, LCID lcid, ITypeInfo** ppTInfo);
    STDMETHOD(GetIDsOfNames)(THIS_ REFIID riid, LPOLESTR* rgszNames, UINT cNames, LCID lcid, DISPID* rgDispId);
    STDMETHOD(Invoke)(THIS_ DISPID dispIdMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult, EXCEPINFO* pExcepInfo, UINT* puArgErr);

    // ISmartICE04Progress
    STDMETHOD(Start)(THIS);
    STDMETHOD(Stop)(THIS);
    STDMETHOD(SetProgress)(THIS_ long lCompleted, long lTotal);
    STDMETHOD(get_Canceled)(THIS_ VARIANT_BOOL* pblCanceled);

    // SupportErrorInfo
    STDMETHOD(InterfaceSupportsErrorInfo)(THIS_ REFIID riid);

    CSmartICE04Progress(ITypeLib* pTlb, ISmartICE04ProgressDialog* pDlg, HWND hWndParent, HRESULT* phr);

private:
    virtual ~CSmartICE04Progress();

    VOID EnableParent(VOID);
    VOID DisableParent(VOID);

    static INT_PTR CALLBACK DlgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
    static DWORD WINAPI ThreadProc(LPVOID lpParameter);
    static LRESULT CALLBACK SubClassProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

    enum Flags
    {
        FLAG_PARENTENABLED = 1U,
        FLAG_PROPERTYVALID = 2U
    };

    static const TCHAR  m_szSmartICE04Progress[];
    volatile HWND       m_hWnd;
    ITaskbarList3*      m_pTaskbarList;
    ITypeInfo*          m_pTypeInfo;
    ITypeInfo*          m_pDispTypeInfo;
    WNDPROC             m_wndproc;
    HWND                m_hWndParent;
    ULONG               m_lRefCount;
    UINT                m_uFlags;
};

#endif