#ifndef CSMARTICE04PROGRESSDIALOG_H
#define CSMARTICE04PROGRESSDIALOG_H

class CSmartICE04ProgressDialog : public ISmartICE04ProgressDialog, public IProvideClassInfo, public ISupportErrorInfo
{
protected:
    inline IUnknown* GetUnknown() { return(static_cast<ISmartICE04ProgressDialog*>(this));   }
    inline HRESULT RaiseCOMException(DISPID dispid, HRESULT hr) { return(::RaiseCOMException(this, dispid, hr));  }

public:
    // IUnknown
    STDMETHOD(QueryInterface) (THIS_ REFIID riid, void** ppvObject);
    STDMETHOD_(ULONG, AddRef) (THIS);
    STDMETHOD_(ULONG, Release)(THIS);

    // IDispatch
    STDMETHOD(GetTypeInfoCount)(THIS_ UINT* pctinfo);
    STDMETHOD(GetTypeInfo)(THIS_ UINT iTInfo, LCID lcid, ITypeInfo** ppTInfo);
    STDMETHOD(GetIDsOfNames)(THIS_ REFIID riid, LPOLESTR* rgszNames, UINT cNames, LCID lcid, DISPID* rgDispId);
    STDMETHOD(Invoke)(THIS_ DISPID dispIdMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult, EXCEPINFO* pExcepInfo, UINT* puArgErr);

    // ISmartICE04ProgressDialog
    STDMETHOD(get_Title)(THIS_ BSTR* Title);
    STDMETHOD(put_Title)(THIS_ BSTR Title);
    STDMETHOD(get_Line1)(THIS_ BSTR* line);
    STDMETHOD(put_Line1)(THIS_ BSTR line);
    STDMETHOD(get_Line2)(THIS_ BSTR* line);
    STDMETHOD(put_Line2)(THIS_ BSTR line);
    STDMETHOD(get_LCID)(THIS_ LCID* lcid);
    STDMETHOD(put_LCID)(THIS_ LCID lcid);
    STDMETHOD(Create)(THIS_ OAHWND hWndParent, IDispatch** ppProgress);

    // IProvideClassInfo
    STDMETHOD(GetClassInfo)(THIS_ ITypeInfo** ppTInfo);

    // ISupportErrorInfo
    STDMETHOD(InterfaceSupportsErrorInfo)(THIS_ REFIID riid);

    CSmartICE04ProgressDialog(HRESULT* phr);

private:
    virtual ~CSmartICE04ProgressDialog();
    HRESULT ChangeBSTR(BSTR* pbstrOld, BSTR bstrNew);
    HRESULT CopyBSTR(BSTR* pbstrDest, BSTR bstrSrc);

    ITypeInfo*  m_pTypeInfo;
    BSTR        m_bstrTitle;
    BSTR        m_bstrLine1;
    BSTR        m_bstrLine2;
    ULONG       m_lRefCount;
    LCID        m_lcid;
};

#endif