#include "precomp.h"

static volatile ULONG_PTR gs_lLockCount = 0;

BOOL WINAPI DllMain(HINSTANCE hinstDll, DWORD fdwReason, LPVOID)
{
    switch(fdwReason)
    {
        case DLL_PROCESS_ATTACH:
            g_hInst = hinstDll;
#ifdef _DLL
            DisableThreadLibraryCalls(g_hInst);
#endif
            break;
        default:
            break;
    }

    return(TRUE);
}

ULONG_PTR LockServer(VOID) throw()
{
    return(InterlockedIncrement(&gs_lLockCount));
}

ULONG_PTR UnlockServer(VOID) throw()
{
    return(InterlockedDecrement(&gs_lLockCount));
}

STDAPI DllCanUnloadNow(VOID)
{
    return((gs_lLockCount) ? S_FALSE : S_OK);
}

#pragma warning(push)
#pragma warning(disable: 6387)
STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, void** ppvObject)
{
    IClassFactory*  pcf;
    HRESULT         hr;

    if(IsBadWritePtrAuto(ppvObject))
        return(E_POINTER);

    *ppvObject = NULL;

    if(IsBadReadPtr(&rclsid, sizeof(CLSID)))
        return(E_INVALIDARG);

    if(IsEqualCLSID(rclsid, CLSID_SmartICE04Devices))
        pcf = new (std::nothrow) CClassFactoryT<CSmartICE04Devices>;
    else if(IsEqualCLSID(rclsid, CLSID_SmartICE04ProgressDialog))
        pcf = new (std::nothrow) CClassFactoryT<CSmartICE04ProgressDialog>;
    else
        return(CLASS_E_CLASSNOTAVAILABLE);

    if(!pcf)
        return(E_OUTOFMEMORY);

    hr = pcf->QueryInterface(riid, ppvObject);
    pcf->Release();
    return(hr);
}
#pragma warning(pop)
