#include "precomp.h"

struct rGroup rGroups[] =  {
  { 0x00, 0x01, "Regs"                              },  // Group 0, show expanded
  { 0x00, 0x01, "Sys"                               },  // Group 1, show expanded
  { 0x00, 0x00, "Interrupts",                       },  // Group 2, show collapsed
  { 0x00, 0x00, "I/O Ports"                         },  // Group 3, show collapsed
  { 0x00, 0x00, "Power Management and Clocks"       },  // Group 4, show collapsed
  { 0x00, 0x00, "FLASH Controller"                  },  // Group 5, show collapsed
  { 0x00, 0x00, "DMA Controller"                    },  // Group 6, show collapsed
  { 0x00, 0x00, "16-bit Timer, Timer 1"             },  // Group 7, show collapsed
  { 0x00, 0x00, "MAC Timer (Timer 2)"               },  // Group 8, show collapsed
  { 0x00, 0x00, "Sleep Timer"                       },  // Group 9, show collapsed
  { 0x00, 0x00, "8-bit Timers, Timer 3 and Timer 4" },  // Group 10, show collapsed
  { 0x00, 0x00, "ADC"                               },  // Group 12, show collapsed
  { 0x00, 0x00, "Random Number Generator"           },  // Group 13, show collapsed
  { 0x00, 0x00, "AES Coprocessor"                   },  // Group 14, show collapsed
  { 0x00, 0x00, "Watchdog Timer"                    },  // Group 15, show collapsed
  { 0x00, 0x00, "USART"                             },  // Group 16, show collapsed
};

#define MAKEITEMID(addr, children)      (((children)) ? ((addr) << 8) : (addr))
#define MAKECHILDID(addr, bitnum)       (((addr) << 8) | (1 << (bitnum)))
#define MAKECHILDMASK(addr, bitmask)    (((addr) << 8) | (bitmask))
#define MAKELASTCHILDID(addr)           (((addr) << 8) | 0xFF)

struct rItem rItems[] =  {
//--desc-nGi-nItem-szReg[]--isPC-cc-iHig--
  { 0x01, 0, 0x00, "r0",      0, 1, 0,  },
  { 0x01, 0, 0x01, "r1",      0, 1, 0,  },
  { 0x01, 0, 0x02, "r2",      0, 1, 0,  },
  { 0x01, 0, 0x03, "r3",      0, 1, 0,  },
  { 0x01, 0, 0x04, "r4",      0, 1, 0,  },
  { 0x01, 0, 0x05, "r5",      0, 1, 0,  },
  { 0x01, 0, 0x06, "r6",      0, 1, 0,  },
  { 0x01, 0, 0x07, "r7",      0, 1, 0,  },

  { 0x01, 1, 0x10, "a",       0, 1, 0,  },
  { 0x01, 1, 0x11, "b",       0, 1, 0,  },
  { 0x01, 1, 0x12, "sp",      0, 1, 0,  },
  { 0x01, 1, 0x13, "dptr",    0, 1, 0,  },
  { 0x01, 1, 0x14, "PC  $",   1, 1, 0,  },
  { 0x01, 1, 0x100,"psw",     0, 1, 0,  },
  { 0x01, 1, 0x101,"p",       0, 1, 0,  },  // child-0
  { 0x01, 1, 0x102,"f1",      0, 1, 0,  },  // child-1
  { 0x01, 1, 0x103,"ov",      0, 1, 0,  },
  { 0x01, 1, 0x104,"rs",      0, 1, 0,  },
  { 0x01, 1, 0x105,"f0",      0, 1, 0,  },
  { 0x01, 1, 0x106,"ac",      0, 1, 0,  },
  { 0x01, 1, 0x107,"cy",      0, 1, 0,  },
  { 0x01, 1, 0x108,"",        0, 0, 0,  },  // End of 'psw' children.

  { 0x01, 2, MAKEITEMID(IEN0, TRUE),        "IEN0",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN0, 7),          "EA",           0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN0, 5),          "STIE",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN0, 4),          "ENCIE",        0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN0, 3),          "URX1IE",       0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN0, 2),          "URX0IE",       0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN0, 1),          "ADCIE",        0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN0, 0),          "RFTXRXIE",     0, 1, 0 },
  { 0x01, 2, MAKELASTCHILDID(IEN0),         "",             0, 1, 0 },
  { 0x01, 2, MAKEITEMID(IEN1, TRUE),        "IEN1",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN1, 5),          "P0IE",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN1, 4),          "T4IE",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN1, 3),          "T3IE",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN1, 2),          "T2IE",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN1, 1),          "T1IE",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN1, 0),          "DMAIE",        0, 1, 0 },
  { 0x01, 2, MAKELASTCHILDID(IEN1),         "",             0, 1, 0 },
  { 0x01, 2, MAKEITEMID(IEN2, TRUE),        "IEN2",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN2, 5),          "WDTIE",        0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN2, 4),          "P1IE",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN2, 3),          "UTX1IE",       0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN2, 2),          "UTX0IE",       0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN2, 1),          "P2IE",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN2, 0),          "RFIE",         0, 1, 0 },
  { 0x01, 2, MAKELASTCHILDID(IEN2),         "",             0, 1, 0 },
  { 0x01, 2, MAKEITEMID(TCON, TRUE),        "TCON",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(TCON, 7),          "URX1IF",       0, 1, 0 },
  { 0x01, 2, MAKECHILDID(TCON, 5),          "ADCIF",        0, 1, 0 },
  { 0x01, 2, MAKECHILDID(TCON, 3),          "URX0IF",       0, 1, 0 },
  { 0x01, 2, MAKECHILDID(TCON, 1),          "RFTXRXIF",     0, 1, 0 },
  { 0x01, 2, MAKELASTCHILDID(TCON),         "",             0, 1, 0 },
  { 0x01, 2, MAKEITEMID(S0CON, TRUE),       "S0CON",        0, 1, 0 },
  { 0x01, 2, MAKECHILDID(S0CON, 1),         "ENCIF_1",      0, 1, 0 },
  { 0x01, 2, MAKECHILDID(S0CON, 0),         "ENCIF_0",      0, 1, 0 },
  { 0x01, 2, MAKELASTCHILDID(S0CON),        "",             0, 1, 0 },
  { 0x01, 2, MAKEITEMID(S1CON, TRUE),       "S1CON",        0, 1, 0 },
  { 0x01, 2, MAKECHILDID(S1CON, 1),         "RFIF_1",       0, 1, 0 },
  { 0x01, 2, MAKECHILDID(S1CON, 0),         "RFIF_0",       0, 1, 0 },
  { 0x01, 2, MAKELASTCHILDID(S1CON),        "",             0, 1, 0 },
  { 0x01, 2, MAKEITEMID(IRCON, TRUE),       "IRCON",        0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IRCON, 7),         "STIF",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IRCON, 5),         "P0IF",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IRCON, 4),         "T4IF",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IRCON, 3),         "T3IF",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IRCON, 2),         "T2IF",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IRCON, 1),         "T1IF",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IRCON, 0),         "DMAIF",        0, 1, 0 },
  { 0x01, 2, MAKELASTCHILDID(IRCON),        "",             0, 1, 0 },
  { 0x01, 2, MAKEITEMID(IRCON2, TRUE),      "IRCON2",       0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IRCON2, 4),        "WDTIF",        0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IRCON2, 3),        "P1IF",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IRCON2, 2),        "UTX1IF",       0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IRCON2, 1),        "UTX0IF",       0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IRCON2, 0),        "P2IF",         0, 1, 0 },
  { 0x01, 2, MAKELASTCHILDID(IRCON2),       "",             0, 1, 0 },
  { 0x01, 2, MAKEITEMID(IP1, TRUE),         "IP1",          0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IP1, 5),           "IP1_IPG5",     0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IP1, 4),           "IP1_IPG4",     0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IP1, 3),           "IP1_IPG3",     0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IP1, 2),           "IP1_IPG2",     0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IP1, 1),           "IP1_IPG1",     0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IP1, 0),           "IP1_IPG0",     0, 1, 0 },
  { 0x01, 2, MAKELASTCHILDID(IP1),          "",             0, 1, 0 },
  { 0x01, 2, MAKEITEMID(IP0, TRUE),         "IP0",          0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IP0, 5),           "IP0_IPG5",     0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IP0, 4),           "IP0_IPG4",     0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IP0, 3),           "IP0_IPG3",     0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IP0, 2),           "IP0_IPG2",     0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IP0, 1),           "IP0_IPG1",     0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IP0, 0),           "IP0_IPG0",     0, 1, 0 },
  { 0x01, 2, MAKELASTCHILDID(IP0),          "",             0, 1, 0 },

  { 0x01, 3, MAKEITEMID(P0, FALSE),         "P0",           0, 1, 0 },
  { 0x01, 3, MAKEITEMID(P1, FALSE),         "P1",           0, 1, 0 },
  { 0x01, 3, MAKEITEMID(P2, FALSE),         "P2",           0, 1, 0 },
  { 0x01, 3, MAKEITEMID(PERCFG, TRUE),      "PERCFG",       0, 1, 0 },
  { 0x01, 3, MAKECHILDID(PERCFG, 6),        "T1CFG",        0, 1, 0 },
  { 0x01, 3, MAKECHILDID(PERCFG, 5),        "T3CFG",        0, 1, 0 },
  { 0x01, 3, MAKECHILDID(PERCFG, 4),        "T4CFG",        0, 1, 0 },
  { 0x01, 3, MAKECHILDID(PERCFG, 1),        "U1CFG",        0, 1, 0 },
  { 0x01, 3, MAKECHILDID(PERCFG, 0),        "U0CFG",        0, 1, 0 },
  { 0x01, 3, MAKELASTCHILDID(PERCFG),       "",             0, 1, 0 },
  { 0x01, 3, MAKEITEMID(ADCCFG, FALSE),     "ADCCFG",       0, 1, 0 },
  { 0x01, 3, MAKEITEMID(P0SEL, FALSE),      "P0SEL",        0, 1, 0 },
  { 0x01, 3, MAKEITEMID(P1SEL, FALSE),      "P1SEL",        0, 1, 0 },
  { 0x01, 3, MAKEITEMID(P2SEL, TRUE),       "P2SEL",        0, 1, 0 },
  { 0x01, 3, MAKECHILDMASK(P2SEL, 0x78),    "PRIP1",        0, 1, 0 },
  { 0x01, 3, MAKECHILDMASK(P2SEL, 0x07),    "SELP2",        0, 1, 0 },
  { 0x01, 3, MAKELASTCHILDID(P2SEL),        "",             0, 1, 0 },
  { 0x01, 3, MAKEITEMID(P0DIR, FALSE),      "P0DIR",        0, 1, 0 },
  { 0x01, 3, MAKEITEMID(P1DIR, FALSE),      "P1DIR",        0, 1, 0 },
  { 0x01, 3, MAKEITEMID(P2DIR, TRUE),       "P2DIR",        0, 1, 0 },
  { 0x01, 3, MAKECHILDMASK(P2DIR, 0xC0),    "PRIP0",        0, 1, 0 },
  { 0x01, 3, MAKECHILDMASK(P2DIR, 0x1F),    "DIRP2",        0, 1, 0 },
  { 0x01, 3, MAKELASTCHILDID(P2DIR),        "",             0, 1, 0 },
  { 0x01, 3, MAKEITEMID(P0INP, FALSE),      "P0INP",        0, 1, 0 },
  { 0x01, 3, MAKEITEMID(P1INP, FALSE),      "P1INP",        0, 1, 0 },
  { 0x01, 3, MAKEITEMID(P2INP, TRUE),       "P2INP",        0, 1, 0 },
  { 0x01, 3, MAKECHILDID(P2INP, 7),         "PDUP2",        0, 1, 0 },
  { 0x01, 3, MAKECHILDID(P2INP, 6),         "PDUP1",        0, 1, 0 },
  { 0x01, 3, MAKECHILDID(P2INP, 5),         "PDUP0",        0, 1, 0 },
  { 0x01, 3, MAKECHILDMASK(P2INP, 0x1F),    "MDP2",         0, 1, 0 },
  { 0x01, 3, MAKELASTCHILDID(P2INP),        "",             0, 1, 0 },
  { 0x01, 3, MAKEITEMID(P0IFG, FALSE),       "P0IFG",       0, 1, 0 },
  { 0x01, 3, MAKEITEMID(P1IFG, FALSE),      "P1IFG",        0, 1, 0 },
  { 0x01, 3, MAKEITEMID(P2IFG, FALSE),      "P2IFG",        0, 1, 0 },
  { 0x01, 3, MAKEITEMID(PICTL, TRUE),       "PICTL",        0, 1, 0 },
  { 0x01, 3, MAKECHILDID(PICTL, 6),         "PADSC",        0, 1, 0 },
  { 0x01, 3, MAKECHILDID(PICTL, 5),         "P2IEN",        0, 1, 0 },
  { 0x01, 3, MAKECHILDID(PICTL, 4),         "P0IENH",       0, 1, 0 },
  { 0x01, 3, MAKECHILDID(PICTL, 3),         "P0IENL",       0, 1, 0 },
  { 0x01, 3, MAKECHILDID(PICTL, 2),         "P2ICON",       0, 1, 0 },
  { 0x01, 3, MAKECHILDID(PICTL, 1),         "P1ICON",       0, 1, 0 },
  { 0x01, 3, MAKECHILDID(PICTL, 0),         "P0ICON",       0, 1, 0 },
  { 0x01, 3, MAKELASTCHILDID(PICTL),        "",             0, 1, 0 },
  { 0x01, 3, MAKEITEMID(P1IEN, FALSE),      "P1IEN",        0, 1, 0 },

  { 0x01, 4, MAKEITEMID(PCON, FALSE),       "PCON",         0, 1, 0 },
  { 0x01, 4, MAKEITEMID(SLEEP, TRUE),       "SLEEP",        0, 1, 0 },
  { 0x01, 4, MAKECHILDID(SLEEP, 6),         "XOSC_STB",     0, 0, 0 },
  { 0x01, 4, MAKECHILDID(SLEEP, 5),         "HFRC_STB",     0, 0, 0 },
  { 0x01, 4, MAKECHILDMASK(SLEEP, 0x18),    "RST",          0, 0, 0 },
  { 0x01, 4, MAKECHILDID(SLEEP, 2),         "OSC_PD",       0, 1, 0 },
  { 0x01, 4, MAKECHILDMASK(SLEEP, 0x03),    "MODE",         0, 1, 0 },
  { 0x01, 4, MAKELASTCHILDID(SLEEP),        "",             0, 1, 0 },
  { 0x01, 4, MAKEITEMID(CLKCON, TRUE),      "CLKCON",       0, 1, 0 },
  { 0x01, 4, MAKECHILDID(CLKCON, 7),        "OSC32K",       0, 1, 0 },
  { 0x01, 4, MAKECHILDID(CLKCON, 6),        "OSC",          0, 1, 0 },
  { 0x01, 4, MAKECHILDMASK(CLKCON, 0x38),   "TICKSPD",      0, 1, 0 },
  { 0x01, 4, MAKECHILDMASK(CLKCON, 0x03),   "CLKSPD",       0, 1, 0 },
  { 0x01, 4, MAKELASTCHILDID(CLKCON),       "",             0, 1, 0 },

  { 0x01, 5, MAKEITEMID(FCTL, TRUE),        "FCTL",         0, 1, 0 },
  { 0x01, 5, MAKECHILDID(FCTL, 7),          "BUSY",         0, 0, 0 },
  { 0x01, 5, MAKECHILDID(FCTL, 6),          "SWBSY",        0, 0, 0 },
  { 0x01, 5, MAKECHILDID(FCTL, 4),          "CONTRD",       0, 1, 0 },
  { 0x01, 5, MAKECHILDID(FCTL, 1),          "WRITE",        0, 1, 0 },
  { 0x01, 5, MAKECHILDID(FCTL, 0),          "ERASE",        0, 1, 0 },
  { 0x01, 5, MAKELASTCHILDID(FCTL),         "",             0, 0, 0 },
  { 0x01, 5, MAKEITEMID(FWDATA, FALSE),     "FWDATA",       0, 1, 0 },
  { 0x01, 5, MAKEITEMID(FADDRH, FALSE),     "FADDRH",       0, 1, 0 },
  { 0x01, 5, MAKEITEMID(FADDRL, FALSE),     "FADDRL",       0, 1, 0 },
  { 0x01, 5, MAKEITEMID(FWT, FALSE),        "FWT",          0, 1, 0 },

  { 0x01, 6, MAKEITEMID(DMAARM, TRUE),      "DMAARM",       0, 1, 0 },
  { 0x01, 6, MAKECHILDID(DMAARM, 7),        "ABORT",        0, 1, 0 },
  { 0x01, 6, MAKECHILDID(DMAARM, 4),        "DMAARM4",      0, 1, 0 },
  { 0x01, 6, MAKECHILDID(DMAARM, 3),        "DMAARM3",      0, 1, 0 },
  { 0x01, 6, MAKECHILDID(DMAARM, 2),        "DMAARM2",      0, 1, 0 },
  { 0x01, 6, MAKECHILDID(DMAARM, 1),        "DMAARM1",      0, 1, 0 },
  { 0x01, 6, MAKECHILDID(DMAARM, 0),        "DMAARM0",      0, 1, 0 },
  { 0x01, 6, MAKELASTCHILDID(DMAARM),       "",             0, 1, 0 },
  { 0x01, 6, MAKEITEMID(DMAREQ, TRUE),      "DMAREQ",       0, 1, 0 },
  { 0x01, 6, MAKECHILDID(DMAREQ, 4),        "DMAREQ4",      0, 1, 0 },
  { 0x01, 6, MAKECHILDID(DMAREQ, 3),        "DMAREQ3",      0, 1, 0 },
  { 0x01, 6, MAKECHILDID(DMAREQ, 2),        "DMAREQ2",      0, 1, 0 },
  { 0x01, 6, MAKECHILDID(DMAREQ, 1),        "DMAREQ1",      0, 1, 0 },
  { 0x01, 6, MAKECHILDID(DMAREQ, 0),        "DMAREQ0",      0, 1, 0 },
  { 0x01, 6, MAKELASTCHILDID(DMAREQ),       "",             0, 1, 0 },
  { 0x01, 6, MAKEITEMID(DMA0CFGH, FALSE),   "DMA0CFGH",     0, 1, 0 },
  { 0x01, 6, MAKEITEMID(DMA0CFGL, FALSE),   "DMA0CFGL",     0, 1, 0 },
  { 0x01, 6, MAKEITEMID(DMA1CFGH, FALSE),   "DMA1CFGH",     0, 1, 0 },
  { 0x01, 6, MAKEITEMID(DMA1CFGL, FALSE),   "DMA1CFGL",     0, 1, 0 },
  { 0x01, 6, MAKEITEMID(DMAIRQ, TRUE),      "DMAIRQ",       0, 1, 0 },
  { 0x01, 6, MAKECHILDID(DMAIRQ, 4),        "DMAIF4",       0, 1, 0 },
  { 0x01, 6, MAKECHILDID(DMAIRQ, 3),        "DMAIF3",       0, 1, 0 },
  { 0x01, 6, MAKECHILDID(DMAIRQ, 2),        "DMAIF2",       0, 1, 0 },
  { 0x01, 6, MAKECHILDID(DMAIRQ, 1),        "DMAIF1",       0, 1, 0 },
  { 0x01, 6, MAKECHILDID(DMAIRQ, 0),        "DMAIF0",       0, 1, 0 },
  { 0x01, 6, MAKELASTCHILDID(DMAIRQ),       "",             0, 1, 0 },

  { 0x01, 7, MAKEITEMID(T1CNTH, FALSE),     "T1CNTH",       0, 0, 0 },
  { 0x01, 7, MAKEITEMID(T1CNTL, FALSE),     "T1CNLH",       0, 1, 0 },
  { 0x01, 7, MAKEITEMID(T1CTL, TRUE),       "T1CTL",        0, 1, 0 },
  { 0x01, 7, MAKECHILDID(T1CTL, 7),         "CH2IF",        0, 1, 0 },
  { 0x01, 7, MAKECHILDID(T1CTL, 6),         "CH1IF",        0, 1, 0 },
  { 0x01, 7, MAKECHILDID(T1CTL, 5),         "CH0IF",        0, 1, 0 },
  { 0x01, 7, MAKECHILDID(T1CTL, 4),         "OVFIF",        0, 1, 0 },
  { 0x01, 7, MAKECHILDMASK(T1CTL, 0x0C),    "DIV",          0, 1, 0 },
  { 0x01, 7, MAKECHILDMASK(T1CTL, 0x03),    "MODE",         0, 1, 0 },
  { 0x01, 7, MAKELASTCHILDID(T1CTL),        "",             0, 1, 0 },
  { 0x01, 7, MAKEITEMID(T1CCTL0, TRUE),     "T1CCTL0",      0, 1, 0 },
  { 0x01, 7, MAKECHILDID(T1CCTL0, 7),       "CPSEL",        0, 1, 0 },
  { 0x01, 7, MAKECHILDID(T1CCTL0, 6),       "IM",           0, 1, 0 },
  { 0x01, 7, MAKECHILDMASK(T1CCTL0, 0x38),  "CMP",          0, 1, 0 },
  { 0x01, 7, MAKECHILDID(T1CCTL0, 2),       "MODE",         0, 1, 0 },
  { 0x01, 7, MAKECHILDMASK(T1CCTL0, 0x03),  "CAP",          0, 1, 0 },
  { 0x01, 7, MAKELASTCHILDID(T1CCTL0),      "",             0, 1, 0 },
  { 0x01, 7, MAKEITEMID(T1CC0H, FALSE),     "T1CC0H",       0, 1, 0 },
  { 0x01, 7, MAKEITEMID(T1CC0L, FALSE),     "T1CC0L",       0, 1, 0 },
  { 0x01, 7, MAKEITEMID(T1CCTL1, TRUE),     "T1CCTL1",      0, 1, 0 },
  { 0x01, 7, MAKECHILDID(T1CCTL1, 7),       "CPSEL",        0, 1, 0 },
  { 0x01, 7, MAKECHILDID(T1CCTL1, 6),       "IM",           0, 1, 0 },
  { 0x01, 7, MAKECHILDMASK(T1CCTL1, 0x38),  "CMP",          0, 1, 0 },
  { 0x01, 7, MAKECHILDID(T1CCTL1, 2),       "MODE",         0, 1, 0 },
  { 0x01, 7, MAKECHILDMASK(T1CCTL1, 0x03),  "CAP",          0, 1, 0 },
  { 0x01, 7, MAKELASTCHILDID(T1CCTL1),      "",             0, 1, 0 },
  { 0x01, 7, MAKEITEMID(T1CC1H, FALSE),     "T1CC1H",       0, 1, 0 },
  { 0x01, 7, MAKEITEMID(T1CC1L, FALSE),     "T1CC1L",       0, 1, 0 },
  { 0x01, 7, MAKEITEMID(T1CCTL2, TRUE),     "T1CCTL2",      0, 1, 0 },
  { 0x01, 7, MAKECHILDID(T1CCTL2, 7),       "CPSEL",        0, 1, 0 },
  { 0x01, 7, MAKECHILDID(T1CCTL2, 6),       "IM",           0, 1, 0 },
  { 0x01, 7, MAKECHILDMASK(T1CCTL2, 0x38),  "CMP",          0, 1, 0 },
  { 0x01, 7, MAKECHILDID(T1CCTL2, 2),       "MODE",         0, 1, 0 },
  { 0x01, 7, MAKECHILDMASK(T1CCTL2, 0x03),  "CAP",          0, 1, 0 },
  { 0x01, 7, MAKELASTCHILDID(T1CCTL2),      "",             0, 1, 0 },
  { 0x01, 7, MAKEITEMID(T1CC2H, FALSE),     "T1CC2H",       0, 1, 0 },
  { 0x01, 7, MAKEITEMID(T1CC2L, FALSE),     "T1CC2L",       0, 1, 0 },

  { 0x01, 8, MAKEITEMID(T2CTL, TRUE),       "T2CTL",        0, 1, 0 },
  { 0x01, 8, MAKECHILDID(T2CTL, 6),         "TEX",          0, 1, 0 },
  { 0x01, 8, MAKECHILDID(T2CTL, 4),         "INT",          0, 1, 0 },
  { 0x01, 8, MAKECHILDID(T2CTL, 2),         "TIG",          0, 1, 0 },
  { 0x01, 8, MAKECHILDMASK(T2CTL, 0x03),    "TIP",          0, 1, 0 },
  { 0x01, 8, MAKELASTCHILDID(T2CTL),        "",             0, 1, 0 },
  { 0x01, 8, MAKEITEMID(T2CT, FALSE),       "T2CT",         0, 1, 0 },
  { 0x01, 8, MAKEITEMID(T2PR, FALSE),       "T2PR",         0, 1, 0 },

  { 0x01, 9, MAKEITEMID(WORTIME0, FALSE),   "WORTIME0",     0, 1, 0 },
  { 0x01, 9, MAKEITEMID(WORTIME1, FALSE),   "WORTIME1",     0, 1, 0 },
  { 0x01, 9, MAKEITEMID(WOREVT1, FALSE),    "WOREVT1",      0, 1, 0 },
  { 0x01, 9, MAKEITEMID(WOREVT0, FALSE),    "WOREVT0",      0, 1, 0 },
  { 0x01, 9, MAKEITEMID(WORCTRL, TRUE),     "WORCTRL",      0, 1, 0 },
  { 0x01, 9, MAKECHILDID(WORCTRL, 2),       "WOR_RESET",    0, 1, 0 },
  { 0x01, 9, MAKECHILDMASK(WORCTRL, 0x03),  "WOR_RES",      0, 1, 0 },
  { 0x01, 9, MAKELASTCHILDID(WORCTRL),      "",             0, 1, 0 },
  { 0x01, 9, MAKEITEMID(WORIRQ, TRUE),      "WORIRQ",       0, 1, 0 },
  { 0x01, 9, MAKECHILDID(WORIRQ, 4),        "EVENT0_MASK",  0, 1, 0 },
  { 0x01, 9, MAKECHILDID(WORIRQ, 0),        "EVENT0_FLAG",  0, 1, 0 },
  { 0x01, 9, MAKELASTCHILDID(WORIRQ),       "",             0, 1, 0 },

  { 0x01, 10, MAKEITEMID(T3CNT, FALSE),     "T3CNT",        0, 0, 0 },
  { 0x01, 10, MAKEITEMID(T3CTL, TRUE),      "T3CTL",        0, 1, 0 },
  { 0x01, 10, MAKECHILDMASK(T3CTL, 0xE0),   "DIV",          0, 1, 0 },
  { 0x01, 10, MAKECHILDID(T3CTL, 4),        "START",        0, 1, 0 },
  { 0x01, 10, MAKECHILDID(T3CTL, 3),        "OVFIM",        0, 1, 0 },
  { 0x01, 10, MAKECHILDID(T3CTL, 2),        "CLR",          0, 1, 0 },
  { 0x01, 10, MAKECHILDMASK(T3CTL, 0x03),   "MODE",         0, 1, 0 },
  { 0x01, 10, MAKELASTCHILDID(T3CTL),       "",             0, 1, 0 },
  { 0x01, 10, MAKEITEMID(T3CCTL0, TRUE),    "T3CCTL0",      0, 1, 0 },
  { 0x01, 10, MAKECHILDID(T3CCTL0, 6),      "IM",           0, 1, 0 },
  { 0x01, 10, MAKECHILDMASK(T3CCTL0, 0x38), "CMP",          0, 1, 0 },
  { 0x01, 10, MAKECHILDID(T3CCTL0, 2),      "MODE",         0, 1, 0 },
  { 0x01, 10, MAKELASTCHILDID(T3CCTL0),     "",             0, 1, 0 },
  { 0x01, 10, MAKEITEMID(T3CC0, FALSE),     "T3CC0",        0, 1, 0 },
  { 0x01, 10, MAKEITEMID(T3CCTL1, TRUE),    "T3CCTL1",      0, 1, 0 },
  { 0x01, 10, MAKECHILDID(T3CCTL1, 6),      "IM",           0, 1, 0 },
  { 0x01, 10, MAKECHILDMASK(T3CCTL1, 0x38), "CMP",          0, 1, 0 },
  { 0x01, 10, MAKECHILDID(T3CCTL1, 2),      "MODE",         0, 1, 0 },
  { 0x01, 10, MAKELASTCHILDID(T3CCTL1),     "",             0, 1, 0 },
  { 0x01, 10, MAKEITEMID(T3CC1, FALSE),     "T3CC1",        0, 1, 0 },
  { 0x01, 10, MAKEITEMID(T4CNT, FALSE),     "T4CNT",        0, 0, 0 },
  { 0x01, 10, MAKEITEMID(T4CTL, TRUE),      "T4CTL",        0, 1, 0 },
  { 0x01, 10, MAKECHILDMASK(T4CTL, 0xE0),   "DIV",          0, 1, 0 },
  { 0x01, 10, MAKECHILDID(T4CTL, 4),        "START",        0, 1, 0 },
  { 0x01, 10, MAKECHILDID(T4CTL, 3),        "OVFIM",        0, 1, 0 },
  { 0x01, 10, MAKECHILDID(T4CTL, 2),        "CLR",          0, 1, 0 },
  { 0x01, 10, MAKECHILDMASK(T4CTL, 0x03),   "MODE",         0, 1, 0 },
  { 0x01, 10, MAKELASTCHILDID(T4CTL),       "",             0, 1, 0 },
  { 0x01, 10, MAKEITEMID(T4CCTL0, TRUE),    "T4CCTL0",      0, 1, 0 },
  { 0x01, 10, MAKECHILDID(T4CCTL0, 6),      "IM",           0, 1, 0 },
  { 0x01, 10, MAKECHILDMASK(T4CCTL0, 0x38), "CMP",          0, 1, 0 },
  { 0x01, 10, MAKECHILDID(T4CCTL0, 2),      "MODE",         0, 1, 0 },
  { 0x01, 10, MAKELASTCHILDID(T4CCTL0),     "",             0, 1, 0 },
  { 0x01, 10, MAKEITEMID(T4CC0, FALSE),     "T4CC0",        0, 1, 0 },
  { 0x01, 10, MAKEITEMID(T4CCTL1, TRUE),    "T4CCTL1",      0, 1, 0 },
  { 0x01, 10, MAKECHILDID(T4CCTL1, 6),      "IM",           0, 1, 0 },
  { 0x01, 10, MAKECHILDMASK(T4CCTL1, 0x38), "CMP",          0, 1, 0 },
  { 0x01, 10, MAKECHILDID(T4CCTL1, 2),      "MODE",         0, 1, 0 },
  { 0x01, 10, MAKELASTCHILDID(T4CCTL1),     "",             0, 1, 0 },
  { 0x01, 10, MAKEITEMID(T4CC1, FALSE),     "T4CC1",        0, 1, 0 },
  { 0x01, 10, MAKEITEMID(TIMIF, TRUE),      "TIMIF",        0, 1, 0 },
  { 0x01, 10, MAKECHILDID(TIMIF, 6),        "OVFIM",        0, 1, 0 },
  { 0x01, 10, MAKECHILDID(TIMIF, 5),        "T4CH1IF",      0, 1, 0 },
  { 0x01, 10, MAKECHILDID(TIMIF, 4),        "T4CH0IF",      0, 1, 0 },
  { 0x01, 10, MAKECHILDID(TIMIF, 3),        "T4OVFIF",      0, 1, 0 },
  { 0x01, 10, MAKECHILDID(TIMIF, 2),        "T3CH1IF",      0, 1, 0 },
  { 0x01, 10, MAKECHILDID(TIMIF, 1),        "T3CH0IF",      0, 1, 0 },
  { 0x01, 10, MAKECHILDID(TIMIF, 0),        "T3OVFIF",      0, 1, 0 },
  { 0x01, 10, MAKELASTCHILDID(TIMIF),       "",             0, 1, 0 },

  { 0x01, 11, MAKEITEMID(ADCL, FALSE),      "ADCL",         0, 0, 0 },
  { 0x01, 11, MAKEITEMID(ADCH, FALSE),      "ADCH",         0, 0, 0 },
  { 0x01, 11, MAKEITEMID(ADCCON1, TRUE),    "ADCCON1",      0, 1, 0 },
  { 0x01, 11, MAKECHILDID(ADCCON1, 7),      "EOC",          0, 0, 0 },
  { 0x01, 11, MAKECHILDID(ADCCON1, 6),      "ST",           0, 1, 0 },
  { 0x01, 11, MAKECHILDMASK(ADCCON1, 0x30), "STSEL",        0, 1, 0 },
  { 0x01, 11, MAKECHILDMASK(ADCCON1, 0x0C), "RCTRL",        0, 1, 0 },
  { 0x01, 11, MAKELASTCHILDID(ADCCON1),     "",             0, 1, 0 },
  { 0x01, 11, MAKEITEMID(ADCCON2, TRUE),    "ADCCON2",      0, 1, 0 },
  { 0x01, 11, MAKECHILDMASK(ADCCON2, 0xC0), "SREF",         0, 1, 0 },
  { 0x01, 11, MAKECHILDMASK(ADCCON2, 0x30), "SDIV",         0, 1, 0 },
  { 0x01, 11, MAKECHILDMASK(ADCCON2, 0x0F), "SCH",          0, 1, 0 },
  { 0x01, 11, MAKELASTCHILDID(ADCCON2),     "",             0, 1, 0 },
  { 0x01, 11, MAKEITEMID(ADCCON3, TRUE),    "ADCCON3",      0, 1, 0 },
  { 0x01, 11, MAKECHILDMASK(ADCCON3, 0xC0), "EREF",         0, 1, 0 },
  { 0x01, 11, MAKECHILDMASK(ADCCON3, 0x30), "EDIV",         0, 1, 0 },
  { 0x01, 11, MAKECHILDMASK(ADCCON3, 0x0F), "ECH",          0, 1, 0 },
  { 0x01, 11, MAKELASTCHILDID(ADCCON3),     "",             0, 1, 0 },

  { 0x01, 12, MAKEITEMID(RNDL, FALSE),      "RNDL",         0, 1, 0 },
  { 0x01, 12, MAKEITEMID(RNDH, FALSE),      "RNDH",         0, 1, 0 },

  { 0x01, 13, MAKEITEMID(ENCCS, TRUE),      "ENCCS",        0, 1, 0 },
  { 0x01, 13, MAKECHILDMASK(ENCCS, 0x70),   "MODE",         0, 1, 0 },
  { 0x01, 13, MAKECHILDID(ENCCS, 3),        "RDY",          0, 0, 0 },
  { 0x01, 13, MAKECHILDMASK(ENCCS, 0x06),   "CMD",          0, 1, 0 },
  { 0x01, 13, MAKELASTCHILDID(ENCCS),       "",             0, 1, 0 },
  { 0x01, 13, MAKEITEMID(ENCDI, FALSE),     "ENCDI",        0, 1, 0 },
  { 0x01, 13, MAKEITEMID(ENCDO, FALSE),     "ENCDO",        0, 1, 0 },

  { 0x01, 14, MAKEITEMID(WDCTL, TRUE),      "WDCTL",        0, 1, 0 },
  { 0x01, 14, MAKECHILDMASK(WDCTL, 0xF0),   "CLR",          0, 1, 0 },
  { 0x01, 14, MAKECHILDID(WDCTL, 3),        "EN",           0, 1, 0 },
  { 0x01, 14, MAKECHILDID(WDCTL, 2),        "MODE",         0, 1, 0 },
  { 0x01, 14, MAKECHILDMASK(WDCTL, 0x03),   "INT",          0, 1, 0 },
  { 0x01, 14, MAKELASTCHILDID(WDCTL),       "",             0, 1, 0 },

  { 0x01, 15, MAKEITEMID(U0CSR, TRUE),      "U0CSR",        0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0CSR, 7),        "MODE",         0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0CSR, 6),        "RE",           0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0CSR, 5),        "SLAVE",        0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0CSR, 4),        "FE",           0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0CSR, 3),        "ERR",          0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0CSR, 2),        "RX_BYTE",      0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0CSR, 1),        "TX_BYTE",      0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0CSR, 0),        "ACTIVE",       0, 0, 0 },
  { 0x01, 15, MAKELASTCHILDID(U0CSR),       "",             0, 1, 0 },
  { 0x01, 15, MAKEITEMID(U0UCR, TRUE),      "U0UCR",        0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0UCR, 7),        "FLUSH",        0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0UCR, 6),        "FLOW",         0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0UCR, 5),        "D9",           0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0UCR, 4),        "BIT9",         0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0UCR, 3),        "PARITY",       0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0UCR, 2),        "SPB",          0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0UCR, 1),        "STOP",         0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0UCR, 0),        "START",        0, 1, 0 },
  { 0x01, 15, MAKELASTCHILDID(U0UCR),       "",             0, 1, 0 },
  { 0x01, 15, MAKEITEMID(U0GCR, TRUE),      "U0GCR",        0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0GCR, 7),        "CPOL",         0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0GCR, 6),        "CPHA",         0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0GCR, 5),        "ORDER",        0, 1, 0 },
  { 0x01, 15, MAKECHILDMASK(U0GCR, 0x1F),   "BAUD_E",       0, 1, 0 },
  { 0x01, 15, MAKELASTCHILDID(U0GCR),       "",             0, 1, 0 },
  { 0x01, 15, MAKEITEMID(U0DBUF, FALSE),    "U0DBUF",       0, 1, 0 },
  { 0x01, 15, MAKEITEMID(U0BAUD, FALSE),    "U0BAUD",       0, 1, 0 },
  { 0x01, 15, MAKEITEMID(U1CSR, TRUE),      "U1CSR",        0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1CSR, 7),        "MODE",         0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1CSR, 6),        "RE",           0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1CSR, 5),        "SLAVE",        0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1CSR, 4),        "FE",           0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1CSR, 3),        "ERR",          0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1CSR, 2),        "RX_BYTE",      0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1CSR, 1),        "TX_BYTE",      0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1CSR, 0),        "ACTIVE",       0, 0, 0 },
  { 0x01, 15, MAKELASTCHILDID(U1CSR),       "",             0, 1, 0 },
  { 0x01, 15, MAKEITEMID(U1UCR, TRUE),      "U1UCR",        0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1UCR, 7),        "FLUSH",        0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1UCR, 6),        "FLOW",         0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1UCR, 5),        "D9",           0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1UCR, 4),        "BIT9",         0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1UCR, 3),        "PARITY",       0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1UCR, 2),        "SPB",          0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1UCR, 1),        "STOP",         0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1UCR, 0),        "START",        0, 1, 0 },
  { 0x01, 15, MAKELASTCHILDID(U1UCR),       "",             0, 1, 0 },
  { 0x01, 15, MAKEITEMID(U1GCR, TRUE),      "U1GCR",        0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1GCR, 7),        "CPOL",         0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1GCR, 6),        "CPHA",         0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1GCR, 5),        "ORDER",        0, 1, 0 },
  { 0x01, 15, MAKECHILDMASK(U1GCR, 0x1F),   "BAUD_E",       0, 1, 0 },
  { 0x01, 15, MAKELASTCHILDID(U1GCR),       "",             0, 1, 0 },
  { 0x01, 15, MAKEITEMID(U1DBUF, FALSE),    "U1DBUF",       0, 1, 0 },
  { 0x01, 15, MAKEITEMID(U1BAUD, FALSE),    "U1BAUD",       0, 1, 0 },
};

struct rItem rItems_Usb[] =  {
//--desc-nGi-nItem-szReg[]--isPC-cc-iHig--
  { 0x01, 0, 0x00, "r0",      0, 1, 0,  },
  { 0x01, 0, 0x01, "r1",      0, 1, 0,  },
  { 0x01, 0, 0x02, "r2",      0, 1, 0,  },
  { 0x01, 0, 0x03, "r3",      0, 1, 0,  },
  { 0x01, 0, 0x04, "r4",      0, 1, 0,  },
  { 0x01, 0, 0x05, "r5",      0, 1, 0,  },
  { 0x01, 0, 0x06, "r6",      0, 1, 0,  },
  { 0x01, 0, 0x07, "r7",      0, 1, 0,  },

  { 0x01, 1, 0x10, "a",       0, 1, 0,  },
  { 0x01, 1, 0x11, "b",       0, 1, 0,  },
  { 0x01, 1, 0x12, "sp",      0, 1, 0,  },
  { 0x01, 1, 0x13, "dptr",    0, 1, 0,  },
  { 0x01, 1, 0x14, "PC  $",   1, 1, 0,  },
  { 0x01, 1, 0x100,"psw",     0, 1, 0,  },
  { 0x01, 1, 0x101,"p",       0, 1, 0,  },  // child-0
  { 0x01, 1, 0x102,"f1",      0, 1, 0,  },  // child-1
  { 0x01, 1, 0x103,"ov",      0, 1, 0,  },
  { 0x01, 1, 0x104,"rs",      0, 1, 0,  },
  { 0x01, 1, 0x105,"f0",      0, 1, 0,  },
  { 0x01, 1, 0x106,"ac",      0, 1, 0,  },
  { 0x01, 1, 0x107,"cy",      0, 1, 0,  },
  { 0x01, 1, 0x108,"",        0, 0, 0,  },  // End of 'psw' children.

  { 0x01, 2, MAKEITEMID(IEN0, TRUE),        "IEN0",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN0, 7),          "EA",           0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN0, 5),          "STIE",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN0, 4),          "ENCIE",        0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN0, 3),          "URX1IE",       0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN0, 2),          "URX0IE",       0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN0, 1),          "ADCIE",        0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN0, 0),          "RFTXRXIE",     0, 1, 0 },
  { 0x01, 2, MAKELASTCHILDID(IEN0),         "",             0, 1, 0 },
  { 0x01, 2, MAKEITEMID(IEN1, TRUE),        "IEN1",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN1, 5),          "P0IE",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN1, 4),          "T4IE",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN1, 3),          "T3IE",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN1, 2),          "T2IE",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN1, 1),          "T1IE",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN1, 0),          "DMAIE",        0, 1, 0 },
  { 0x01, 2, MAKELASTCHILDID(IEN1),         "",             0, 1, 0 },
  { 0x01, 2, MAKEITEMID(IEN2, TRUE),        "IEN2",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN2, 5),          "WDTIE",        0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN2, 4),          "P1IE",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN2, 3),          "UTX1IE",       0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN2, 2),          "UTX0IE",       0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN2, 1),          "P2IE",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IEN2, 0),          "RFIE",         0, 1, 0 },
  { 0x01, 2, MAKELASTCHILDID(IEN2),         "",             0, 1, 0 },
  { 0x01, 2, MAKEITEMID(TCON, TRUE),        "TCON",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(TCON, 7),          "URX1IF",       0, 1, 0 },
  { 0x01, 2, MAKECHILDID(TCON, 5),          "ADCIF",        0, 1, 0 },
  { 0x01, 2, MAKECHILDID(TCON, 3),          "URX0IF",       0, 1, 0 },
  { 0x01, 2, MAKECHILDID(TCON, 1),          "RFTXRXIF",     0, 1, 0 },
  { 0x01, 2, MAKELASTCHILDID(TCON),         "",             0, 1, 0 },
  { 0x01, 2, MAKEITEMID(S0CON, TRUE),       "S0CON",        0, 1, 0 },
  { 0x01, 2, MAKECHILDID(S0CON, 1),         "ENCIF_1",      0, 1, 0 },
  { 0x01, 2, MAKECHILDID(S0CON, 0),         "ENCIF_0",      0, 1, 0 },
  { 0x01, 2, MAKELASTCHILDID(S0CON),        "",             0, 1, 0 },
  { 0x01, 2, MAKEITEMID(S1CON, TRUE),       "S1CON",        0, 1, 0 },
  { 0x01, 2, MAKECHILDID(S1CON, 1),         "RFIF_1",       0, 1, 0 },
  { 0x01, 2, MAKECHILDID(S1CON, 0),         "RFIF_0",       0, 1, 0 },
  { 0x01, 2, MAKELASTCHILDID(S1CON),        "",             0, 1, 0 },
  { 0x01, 2, MAKEITEMID(IRCON, TRUE),       "IRCON",        0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IRCON, 7),         "STIF",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IRCON, 5),         "P0IF",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IRCON, 4),         "T4IF",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IRCON, 3),         "T3IF",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IRCON, 2),         "T2IF",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IRCON, 1),         "T1IF",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IRCON, 0),         "DMAIF",        0, 1, 0 },
  { 0x01, 2, MAKELASTCHILDID(IRCON),        "",             0, 1, 0 },
  { 0x01, 2, MAKEITEMID(IRCON2, TRUE),      "IRCON2",       0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IRCON2, 4),        "WDTIF",        0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IRCON2, 3),        "P1IF",         0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IRCON2, 2),        "UTX1IF",       0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IRCON2, 1),        "UTX0IF",       0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IRCON2, 0),        "P2IF",         0, 1, 0 },
  { 0x01, 2, MAKELASTCHILDID(IRCON2),       "",             0, 1, 0 },
  { 0x01, 2, MAKEITEMID(IP1, TRUE),         "IP1",          0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IP1, 5),           "IP1_IPG5",     0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IP1, 4),           "IP1_IPG4",     0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IP1, 3),           "IP1_IPG3",     0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IP1, 2),           "IP1_IPG2",     0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IP1, 1),           "IP1_IPG1",     0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IP1, 0),           "IP1_IPG0",     0, 1, 0 },
  { 0x01, 2, MAKELASTCHILDID(IP1),          "",             0, 1, 0 },
  { 0x01, 2, MAKEITEMID(IP0, TRUE),         "IP0",          0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IP0, 5),           "IP0_IPG5",     0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IP0, 4),           "IP0_IPG4",     0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IP0, 3),           "IP0_IPG3",     0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IP0, 2),           "IP0_IPG2",     0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IP0, 1),           "IP0_IPG1",     0, 1, 0 },
  { 0x01, 2, MAKECHILDID(IP0, 0),           "IP0_IPG0",     0, 1, 0 },
  { 0x01, 2, MAKELASTCHILDID(IP0),          "",             0, 1, 0 },

  { 0x01, 3, MAKEITEMID(P0, FALSE),         "P0",           0, 1, 0 },
  { 0x01, 3, MAKEITEMID(P1, FALSE),         "P1",           0, 1, 0 },
  { 0x01, 3, MAKEITEMID(P2, FALSE),         "P2",           0, 1, 0 },
  { 0x01, 3, MAKEITEMID(PERCFG, TRUE),      "PERCFG",       0, 1, 0 },
  { 0x01, 3, MAKECHILDID(PERCFG, 6),        "T1CFG",        0, 1, 0 },
  { 0x01, 3, MAKECHILDID(PERCFG, 5),        "T3CFG",        0, 1, 0 },
  { 0x01, 3, MAKECHILDID(PERCFG, 4),        "T4CFG",        0, 1, 0 },
  { 0x01, 3, MAKECHILDID(PERCFG, 1),        "U1CFG",        0, 1, 0 },
  { 0x01, 3, MAKECHILDID(PERCFG, 0),        "U0CFG",        0, 1, 0 },
  { 0x01, 3, MAKELASTCHILDID(PERCFG),       "",             0, 1, 0 },
  { 0x01, 3, MAKEITEMID(ADCCFG, FALSE),     "ADCCFG",       0, 1, 0 },
  { 0x01, 3, MAKEITEMID(P0SEL, FALSE),      "P0SEL",        0, 1, 0 },
  { 0x01, 3, MAKEITEMID(P1SEL, FALSE),      "P1SEL",        0, 1, 0 },
  { 0x01, 3, MAKEITEMID(P2SEL, TRUE),       "P2SEL",        0, 1, 0 },
  { 0x01, 3, MAKECHILDMASK(P2SEL, 0x78),    "PRIP1",        0, 1, 0 },
  { 0x01, 3, MAKECHILDMASK(P2SEL, 0x07),    "SELP2",        0, 1, 0 },
  { 0x01, 3, MAKELASTCHILDID(P2SEL),        "",             0, 1, 0 },
  { 0x01, 3, MAKEITEMID(P0DIR, FALSE),      "P0DIR",        0, 1, 0 },
  { 0x01, 3, MAKEITEMID(P1DIR, FALSE),      "P1DIR",        0, 1, 0 },
  { 0x01, 3, MAKEITEMID(P2DIR, TRUE),       "P2DIR",        0, 1, 0 },
  { 0x01, 3, MAKECHILDMASK(P2DIR, 0xC0),    "PRIP0",        0, 1, 0 },
  { 0x01, 3, MAKECHILDMASK(P2DIR, 0x1F),    "DIRP2",        0, 1, 0 },
  { 0x01, 3, MAKELASTCHILDID(P2DIR),        "",             0, 1, 0 },
  { 0x01, 3, MAKEITEMID(P0INP, FALSE),      "P0INP",        0, 1, 0 },
  { 0x01, 3, MAKEITEMID(P1INP, FALSE),      "P1INP",        0, 1, 0 },
  { 0x01, 3, MAKEITEMID(P2INP, TRUE),       "P2INP",        0, 1, 0 },
  { 0x01, 3, MAKECHILDID(P2INP, 7),         "PDUP2",        0, 1, 0 },
  { 0x01, 3, MAKECHILDID(P2INP, 6),         "PDUP1",        0, 1, 0 },
  { 0x01, 3, MAKECHILDID(P2INP, 5),         "PDUP0",        0, 1, 0 },
  { 0x01, 3, MAKECHILDMASK(P2INP, 0x1F),    "MDP2",         0, 1, 0 },
  { 0x01, 3, MAKELASTCHILDID(P2INP),        "",             0, 1, 0 },
  { 0x01, 3, MAKEITEMID(P0IFG, TRUE),       "P0IFG",        0, 1, 0 },
  { 0x01, 3, MAKECHILDID(P0IFG, 7),         "USB_RESUME",   0, 1, 0 },
  { 0x01, 3, MAKECHILDMASK(P0IFG, 0x3F),    "P0IF",         0, 1, 0 },
  { 0x01, 3, MAKELASTCHILDID(P0IFG),        "",             0, 1, 0 },
  { 0x01, 3, MAKEITEMID(P1IFG, FALSE),      "P1IFG",        0, 1, 0 },
  { 0x01, 3, MAKEITEMID(P2IFG, FALSE),      "P2IFG",        0, 1, 0 },
  { 0x01, 3, MAKEITEMID(PICTL, TRUE),       "PICTL",        0, 1, 0 },
  { 0x01, 3, MAKECHILDID(PICTL, 6),         "PADSC",        0, 1, 0 },
  { 0x01, 3, MAKECHILDID(PICTL, 5),         "P2IEN",        0, 1, 0 },
  { 0x01, 3, MAKECHILDID(PICTL, 4),         "P0IENH",       0, 1, 0 },
  { 0x01, 3, MAKECHILDID(PICTL, 3),         "P0IENL",       0, 1, 0 },
  { 0x01, 3, MAKECHILDID(PICTL, 2),         "P2ICON",       0, 1, 0 },
  { 0x01, 3, MAKECHILDID(PICTL, 1),         "P1ICON",       0, 1, 0 },
  { 0x01, 3, MAKECHILDID(PICTL, 0),         "P0ICON",       0, 1, 0 },
  { 0x01, 3, MAKELASTCHILDID(PICTL),        "",             0, 1, 0 },
  { 0x01, 3, MAKEITEMID(P1IEN, FALSE),      "P1IEN",        0, 1, 0 },

  { 0x01, 4, MAKEITEMID(PCON, FALSE),       "PCON",         0, 1, 0 },
  { 0x01, 4, MAKEITEMID(SLEEP, TRUE),       "SLEEP",        0, 1, 0 },
  { 0x01, 4, MAKECHILDID(SLEEP, 7),         "USB_EN",       0, 1, 0 },
  { 0x01, 4, MAKECHILDID(SLEEP, 6),         "XOSC_STB",     0, 0, 0 },
  { 0x01, 4, MAKECHILDID(SLEEP, 5),         "HFRC_STB",     0, 0, 0 },
  { 0x01, 4, MAKECHILDMASK(SLEEP, 0x18),    "RST",          0, 0, 0 },
  { 0x01, 4, MAKECHILDID(SLEEP, 2),         "OSC_PD",       0, 1, 0 },
  { 0x01, 4, MAKECHILDMASK(SLEEP, 0x03),    "MODE",         0, 1, 0 },
  { 0x01, 4, MAKELASTCHILDID(SLEEP),        "",             0, 1, 0 },
  { 0x01, 4, MAKEITEMID(CLKCON, TRUE),      "CLKCON",       0, 1, 0 },
  { 0x01, 4, MAKECHILDID(CLKCON, 7),        "OSC32K",       0, 1, 0 },
  { 0x01, 4, MAKECHILDID(CLKCON, 6),        "OSC",          0, 1, 0 },
  { 0x01, 4, MAKECHILDMASK(CLKCON, 0x38),   "TICKSPD",      0, 1, 0 },
  { 0x01, 4, MAKECHILDMASK(CLKCON, 0x03),   "CLKSPD",       0, 1, 0 },
  { 0x01, 4, MAKELASTCHILDID(CLKCON),       "",             0, 1, 0 },

  { 0x01, 5, MAKEITEMID(FCTL, TRUE),        "FCTL",         0, 1, 0 },
  { 0x01, 5, MAKECHILDID(FCTL, 7),          "BUSY",         0, 0, 0 },
  { 0x01, 5, MAKECHILDID(FCTL, 6),          "SWBSY",        0, 0, 0 },
  { 0x01, 5, MAKECHILDID(FCTL, 4),          "CONTRD",       0, 1, 0 },
  { 0x01, 5, MAKECHILDID(FCTL, 1),          "WRITE",        0, 1, 0 },
  { 0x01, 5, MAKECHILDID(FCTL, 0),          "ERASE",        0, 1, 0 },
  { 0x01, 5, MAKELASTCHILDID(FCTL),         "",             0, 0, 0 },
  { 0x01, 5, MAKEITEMID(FWDATA, FALSE),     "FWDATA",       0, 1, 0 },
  { 0x01, 5, MAKEITEMID(FADDRH, FALSE),     "FADDRH",       0, 1, 0 },
  { 0x01, 5, MAKEITEMID(FADDRL, FALSE),     "FADDRL",       0, 1, 0 },
  { 0x01, 5, MAKEITEMID(FWT, FALSE),        "FWT",          0, 1, 0 },

  { 0x01, 6, MAKEITEMID(DMAARM, TRUE),      "DMAARM",       0, 1, 0 },
  { 0x01, 6, MAKECHILDID(DMAARM, 7),        "ABORT",        0, 1, 0 },
  { 0x01, 6, MAKECHILDID(DMAARM, 4),        "DMAARM4",      0, 1, 0 },
  { 0x01, 6, MAKECHILDID(DMAARM, 3),        "DMAARM3",      0, 1, 0 },
  { 0x01, 6, MAKECHILDID(DMAARM, 2),        "DMAARM2",      0, 1, 0 },
  { 0x01, 6, MAKECHILDID(DMAARM, 1),        "DMAARM1",      0, 1, 0 },
  { 0x01, 6, MAKECHILDID(DMAARM, 0),        "DMAARM0",      0, 1, 0 },
  { 0x01, 6, MAKELASTCHILDID(DMAARM),       "",             0, 1, 0 },
  { 0x01, 6, MAKEITEMID(DMAREQ, TRUE),      "DMAREQ",       0, 1, 0 },
  { 0x01, 6, MAKECHILDID(DMAREQ, 4),        "DMAREQ4",      0, 1, 0 },
  { 0x01, 6, MAKECHILDID(DMAREQ, 3),        "DMAREQ3",      0, 1, 0 },
  { 0x01, 6, MAKECHILDID(DMAREQ, 2),        "DMAREQ2",      0, 1, 0 },
  { 0x01, 6, MAKECHILDID(DMAREQ, 1),        "DMAREQ1",      0, 1, 0 },
  { 0x01, 6, MAKECHILDID(DMAREQ, 0),        "DMAREQ0",      0, 1, 0 },
  { 0x01, 6, MAKELASTCHILDID(DMAREQ),       "",             0, 1, 0 },
  { 0x01, 6, MAKEITEMID(DMA0CFGH, FALSE),   "DMA0CFGH",     0, 1, 0 },
  { 0x01, 6, MAKEITEMID(DMA0CFGL, FALSE),   "DMA0CFGL",     0, 1, 0 },
  { 0x01, 6, MAKEITEMID(DMA1CFGH, FALSE),   "DMA1CFGH",     0, 1, 0 },
  { 0x01, 6, MAKEITEMID(DMA1CFGL, FALSE),   "DMA1CFGL",     0, 1, 0 },
  { 0x01, 6, MAKEITEMID(DMAIRQ, TRUE),      "DMAIRQ",       0, 1, 0 },
  { 0x01, 6, MAKECHILDID(DMAIRQ, 4),        "DMAIF4",       0, 1, 0 },
  { 0x01, 6, MAKECHILDID(DMAIRQ, 3),        "DMAIF3",       0, 1, 0 },
  { 0x01, 6, MAKECHILDID(DMAIRQ, 2),        "DMAIF2",       0, 1, 0 },
  { 0x01, 6, MAKECHILDID(DMAIRQ, 1),        "DMAIF1",       0, 1, 0 },
  { 0x01, 6, MAKECHILDID(DMAIRQ, 0),        "DMAIF0",       0, 1, 0 },
  { 0x01, 6, MAKELASTCHILDID(DMAIRQ),       "",             0, 1, 0 },
  { 0x01, 6, MAKEITEMID(ENDIAN, TRUE),      "ENDIAN",       0, 1, 0 },
  { 0x01, 6, MAKECHILDID(ENDIAN, 1),        "USBWLE",       0, 1, 0 },
  { 0x01, 6, MAKECHILDID(ENDIAN, 0),        "USBRLE",       0, 1, 0 },
  { 0x01, 6, MAKELASTCHILDID(ENDIAN),       "",             0, 1, 0 },

  { 0x01, 7, MAKEITEMID(T1CNTH, FALSE),     "T1CNTH",       0, 0, 0 },
  { 0x01, 7, MAKEITEMID(T1CNTL, FALSE),     "T1CNLH",       0, 1, 0 },
  { 0x01, 7, MAKEITEMID(T1CTL, TRUE),       "T1CTL",        0, 1, 0 },
  { 0x01, 7, MAKECHILDID(T1CTL, 7),         "CH2IF",        0, 1, 0 },
  { 0x01, 7, MAKECHILDID(T1CTL, 6),         "CH1IF",        0, 1, 0 },
  { 0x01, 7, MAKECHILDID(T1CTL, 5),         "CH0IF",        0, 1, 0 },
  { 0x01, 7, MAKECHILDID(T1CTL, 4),         "OVFIF",        0, 1, 0 },
  { 0x01, 7, MAKECHILDMASK(T1CTL, 0x0C),    "DIV",          0, 1, 0 },
  { 0x01, 7, MAKECHILDMASK(T1CTL, 0x03),    "MODE",         0, 1, 0 },
  { 0x01, 7, MAKELASTCHILDID(T1CTL),        "",             0, 1, 0 },
  { 0x01, 7, MAKEITEMID(T1CCTL0, TRUE),     "T1CCTL0",      0, 1, 0 },
  { 0x01, 7, MAKECHILDID(T1CCTL0, 7),       "CPSEL",        0, 1, 0 },
  { 0x01, 7, MAKECHILDID(T1CCTL0, 6),       "IM",           0, 1, 0 },
  { 0x01, 7, MAKECHILDMASK(T1CCTL0, 0x38),  "CMP",          0, 1, 0 },
  { 0x01, 7, MAKECHILDID(T1CCTL0, 2),       "MODE",         0, 1, 0 },
  { 0x01, 7, MAKECHILDMASK(T1CCTL0, 0x03),  "CAP",          0, 1, 0 },
  { 0x01, 7, MAKELASTCHILDID(T1CCTL0),      "",             0, 1, 0 },
  { 0x01, 7, MAKEITEMID(T1CC0H, FALSE),     "T1CC0H",       0, 1, 0 },
  { 0x01, 7, MAKEITEMID(T1CC0L, FALSE),     "T1CC0L",       0, 1, 0 },
  { 0x01, 7, MAKEITEMID(T1CCTL1, TRUE),     "T1CCTL1",      0, 1, 0 },
  { 0x01, 7, MAKECHILDID(T1CCTL1, 7),       "CPSEL",        0, 1, 0 },
  { 0x01, 7, MAKECHILDID(T1CCTL1, 6),       "IM",           0, 1, 0 },
  { 0x01, 7, MAKECHILDMASK(T1CCTL1, 0x38),  "CMP",          0, 1, 0 },
  { 0x01, 7, MAKECHILDID(T1CCTL1, 2),       "MODE",         0, 1, 0 },
  { 0x01, 7, MAKECHILDMASK(T1CCTL1, 0x03),  "CAP",          0, 1, 0 },
  { 0x01, 7, MAKELASTCHILDID(T1CCTL1),      "",             0, 1, 0 },
  { 0x01, 7, MAKEITEMID(T1CC1H, FALSE),     "T1CC1H",       0, 1, 0 },
  { 0x01, 7, MAKEITEMID(T1CC1L, FALSE),     "T1CC1L",       0, 1, 0 },
  { 0x01, 7, MAKEITEMID(T1CCTL2, TRUE),     "T1CCTL2",      0, 1, 0 },
  { 0x01, 7, MAKECHILDID(T1CCTL2, 7),       "CPSEL",        0, 1, 0 },
  { 0x01, 7, MAKECHILDID(T1CCTL2, 6),       "IM",           0, 1, 0 },
  { 0x01, 7, MAKECHILDMASK(T1CCTL2, 0x38),  "CMP",          0, 1, 0 },
  { 0x01, 7, MAKECHILDID(T1CCTL2, 2),       "MODE",         0, 1, 0 },
  { 0x01, 7, MAKECHILDMASK(T1CCTL2, 0x03),  "CAP",          0, 1, 0 },
  { 0x01, 7, MAKELASTCHILDID(T1CCTL2),      "",             0, 1, 0 },
  { 0x01, 7, MAKEITEMID(T1CC2H, FALSE),     "T1CC2H",       0, 1, 0 },
  { 0x01, 7, MAKEITEMID(T1CC2L, FALSE),     "T1CC2L",       0, 1, 0 },

  { 0x01, 8, MAKEITEMID(T2CTL, TRUE),       "T2CTL",        0, 1, 0 },
  { 0x01, 8, MAKECHILDID(T2CTL, 6),         "TEX",          0, 1, 0 },
  { 0x01, 8, MAKECHILDID(T2CTL, 4),         "INT",          0, 1, 0 },
  { 0x01, 8, MAKECHILDID(T2CTL, 2),         "TIG",          0, 1, 0 },
  { 0x01, 8, MAKECHILDMASK(T2CTL, 0x03),    "TIP",          0, 1, 0 },
  { 0x01, 8, MAKELASTCHILDID(T2CTL),        "",             0, 1, 0 },
  { 0x01, 8, MAKEITEMID(T2CT, FALSE),       "T2CT",         0, 1, 0 },
  { 0x01, 8, MAKEITEMID(T2PR, FALSE),       "T2PR",         0, 1, 0 },

  { 0x01, 9, MAKEITEMID(WORTIME0, FALSE),   "WORTIME0",     0, 1, 0 },
  { 0x01, 9, MAKEITEMID(WORTIME1, FALSE),   "WORTIME1",     0, 1, 0 },
  { 0x01, 9, MAKEITEMID(WOREVT1, FALSE),    "WOREVT1",      0, 1, 0 },
  { 0x01, 9, MAKEITEMID(WOREVT0, FALSE),    "WOREVT0",      0, 1, 0 },
  { 0x01, 9, MAKEITEMID(WORCTRL, TRUE),     "WORCTRL",      0, 1, 0 },
  { 0x01, 9, MAKECHILDID(WORCTRL, 2),       "WOR_RESET",    0, 1, 0 },
  { 0x01, 9, MAKECHILDMASK(WORCTRL, 0x03),  "WOR_RES",      0, 1, 0 },
  { 0x01, 9, MAKELASTCHILDID(WORCTRL),      "",             0, 1, 0 },
  { 0x01, 9, MAKEITEMID(WORIRQ, TRUE),      "WORIRQ",       0, 1, 0 },
  { 0x01, 9, MAKECHILDID(WORIRQ, 4),        "EVENT0_MASK",  0, 1, 0 },
  { 0x01, 9, MAKECHILDID(WORIRQ, 0),        "EVENT0_FLAG",  0, 1, 0 },
  { 0x01, 9, MAKELASTCHILDID(WORIRQ),       "",             0, 1, 0 },

  { 0x01, 10, MAKEITEMID(T3CNT, FALSE),     "T3CNT",        0, 0, 0 },
  { 0x01, 10, MAKEITEMID(T3CTL, TRUE),      "T3CTL",        0, 1, 0 },
  { 0x01, 10, MAKECHILDMASK(T3CTL, 0xE0),   "DIV",          0, 1, 0 },
  { 0x01, 10, MAKECHILDID(T3CTL, 4),        "START",        0, 1, 0 },
  { 0x01, 10, MAKECHILDID(T3CTL, 3),        "OVFIM",        0, 1, 0 },
  { 0x01, 10, MAKECHILDID(T3CTL, 2),        "CLR",          0, 1, 0 },
  { 0x01, 10, MAKECHILDMASK(T3CTL, 0x03),   "MODE",         0, 1, 0 },
  { 0x01, 10, MAKELASTCHILDID(T3CTL),       "",             0, 1, 0 },
  { 0x01, 10, MAKEITEMID(T3CCTL0, TRUE),    "T3CCTL0",      0, 1, 0 },
  { 0x01, 10, MAKECHILDID(T3CCTL0, 6),      "IM",           0, 1, 0 },
  { 0x01, 10, MAKECHILDMASK(T3CCTL0, 0x38), "CMP",          0, 1, 0 },
  { 0x01, 10, MAKECHILDID(T3CCTL0, 2),      "MODE",         0, 1, 0 },
  { 0x01, 10, MAKELASTCHILDID(T3CCTL0),     "",             0, 1, 0 },
  { 0x01, 10, MAKEITEMID(T3CC0, FALSE),     "T3CC0",        0, 1, 0 },
  { 0x01, 10, MAKEITEMID(T3CCTL1, TRUE),    "T3CCTL1",      0, 1, 0 },
  { 0x01, 10, MAKECHILDID(T3CCTL1, 6),      "IM",           0, 1, 0 },
  { 0x01, 10, MAKECHILDMASK(T3CCTL1, 0x38), "CMP",          0, 1, 0 },
  { 0x01, 10, MAKECHILDID(T3CCTL1, 2),      "MODE",         0, 1, 0 },
  { 0x01, 10, MAKELASTCHILDID(T3CCTL1),     "",             0, 1, 0 },
  { 0x01, 10, MAKEITEMID(T3CC1, FALSE),     "T3CC1",        0, 1, 0 },
  { 0x01, 10, MAKEITEMID(T4CNT, FALSE),     "T4CNT",        0, 0, 0 },
  { 0x01, 10, MAKEITEMID(T4CTL, TRUE),      "T4CTL",        0, 1, 0 },
  { 0x01, 10, MAKECHILDMASK(T4CTL, 0xE0),   "DIV",          0, 1, 0 },
  { 0x01, 10, MAKECHILDID(T4CTL, 4),        "START",        0, 1, 0 },
  { 0x01, 10, MAKECHILDID(T4CTL, 3),        "OVFIM",        0, 1, 0 },
  { 0x01, 10, MAKECHILDID(T4CTL, 2),        "CLR",          0, 1, 0 },
  { 0x01, 10, MAKECHILDMASK(T4CTL, 0x03),   "MODE",         0, 1, 0 },
  { 0x01, 10, MAKELASTCHILDID(T4CTL),       "",             0, 1, 0 },
  { 0x01, 10, MAKEITEMID(T4CCTL0, TRUE),    "T4CCTL0",      0, 1, 0 },
  { 0x01, 10, MAKECHILDID(T4CCTL0, 6),      "IM",           0, 1, 0 },
  { 0x01, 10, MAKECHILDMASK(T4CCTL0, 0x38), "CMP",          0, 1, 0 },
  { 0x01, 10, MAKECHILDID(T4CCTL0, 2),      "MODE",         0, 1, 0 },
  { 0x01, 10, MAKELASTCHILDID(T4CCTL0),     "",             0, 1, 0 },
  { 0x01, 10, MAKEITEMID(T4CC0, FALSE),     "T4CC0",        0, 1, 0 },
  { 0x01, 10, MAKEITEMID(T4CCTL1, TRUE),    "T4CCTL1",      0, 1, 0 },
  { 0x01, 10, MAKECHILDID(T4CCTL1, 6),      "IM",           0, 1, 0 },
  { 0x01, 10, MAKECHILDMASK(T4CCTL1, 0x38), "CMP",          0, 1, 0 },
  { 0x01, 10, MAKECHILDID(T4CCTL1, 2),      "MODE",         0, 1, 0 },
  { 0x01, 10, MAKELASTCHILDID(T4CCTL1),     "",             0, 1, 0 },
  { 0x01, 10, MAKEITEMID(T4CC1, FALSE),     "T4CC1",        0, 1, 0 },
  { 0x01, 10, MAKEITEMID(TIMIF, TRUE),      "TIMIF",        0, 1, 0 },
  { 0x01, 10, MAKECHILDID(TIMIF, 6),        "OVFIM",        0, 1, 0 },
  { 0x01, 10, MAKECHILDID(TIMIF, 5),        "T4CH1IF",      0, 1, 0 },
  { 0x01, 10, MAKECHILDID(TIMIF, 4),        "T4CH0IF",      0, 1, 0 },
  { 0x01, 10, MAKECHILDID(TIMIF, 3),        "T4OVFIF",      0, 1, 0 },
  { 0x01, 10, MAKECHILDID(TIMIF, 2),        "T3CH1IF",      0, 1, 0 },
  { 0x01, 10, MAKECHILDID(TIMIF, 1),        "T3CH0IF",      0, 1, 0 },
  { 0x01, 10, MAKECHILDID(TIMIF, 0),        "T3OVFIF",      0, 1, 0 },
  { 0x01, 10, MAKELASTCHILDID(TIMIF),       "",             0, 1, 0 },

  { 0x01, 11, MAKEITEMID(ADCL, FALSE),      "ADCL",         0, 0, 0 },
  { 0x01, 11, MAKEITEMID(ADCH, FALSE),      "ADCH",         0, 0, 0 },
  { 0x01, 11, MAKEITEMID(ADCCON1, TRUE),    "ADCCON1",      0, 1, 0 },
  { 0x01, 11, MAKECHILDID(ADCCON1, 7),      "EOC",          0, 0, 0 },
  { 0x01, 11, MAKECHILDID(ADCCON1, 6),      "ST",           0, 1, 0 },
  { 0x01, 11, MAKECHILDMASK(ADCCON1, 0x30), "STSEL",        0, 1, 0 },
  { 0x01, 11, MAKECHILDMASK(ADCCON1, 0x0C), "RCTRL",        0, 1, 0 },
  { 0x01, 11, MAKELASTCHILDID(ADCCON1),     "",             0, 1, 0 },
  { 0x01, 11, MAKEITEMID(ADCCON2, TRUE),    "ADCCON2",      0, 1, 0 },
  { 0x01, 11, MAKECHILDMASK(ADCCON2, 0xC0), "SREF",         0, 1, 0 },
  { 0x01, 11, MAKECHILDMASK(ADCCON2, 0x30), "SDIV",         0, 1, 0 },
  { 0x01, 11, MAKECHILDMASK(ADCCON2, 0x0F), "SCH",          0, 1, 0 },
  { 0x01, 11, MAKELASTCHILDID(ADCCON2),     "",             0, 1, 0 },
  { 0x01, 11, MAKEITEMID(ADCCON3, TRUE),    "ADCCON3",      0, 1, 0 },
  { 0x01, 11, MAKECHILDMASK(ADCCON3, 0xC0), "EREF",         0, 1, 0 },
  { 0x01, 11, MAKECHILDMASK(ADCCON3, 0x30), "EDIV",         0, 1, 0 },
  { 0x01, 11, MAKECHILDMASK(ADCCON3, 0x0F), "ECH",          0, 1, 0 },
  { 0x01, 11, MAKELASTCHILDID(ADCCON3),     "",             0, 1, 0 },

  { 0x01, 12, MAKEITEMID(RNDL, FALSE),      "RNDL",         0, 1, 0 },
  { 0x01, 12, MAKEITEMID(RNDH, FALSE),      "RNDH",         0, 1, 0 },

  { 0x01, 13, MAKEITEMID(ENCCS, TRUE),      "ENCCS",        0, 1, 0 },
  { 0x01, 13, MAKECHILDMASK(ENCCS, 0x70),   "MODE",         0, 1, 0 },
  { 0x01, 13, MAKECHILDID(ENCCS, 3),        "RDY",          0, 0, 0 },
  { 0x01, 13, MAKECHILDMASK(ENCCS, 0x06),   "CMD",          0, 1, 0 },
  { 0x01, 13, MAKELASTCHILDID(ENCCS),       "",             0, 1, 0 },
  { 0x01, 13, MAKEITEMID(ENCDI, FALSE),     "ENCDI",        0, 1, 0 },
  { 0x01, 13, MAKEITEMID(ENCDO, FALSE),     "ENCDO",        0, 1, 0 },

  { 0x01, 14, MAKEITEMID(WDCTL, TRUE),      "WDCTL",        0, 1, 0 },
  { 0x01, 14, MAKECHILDMASK(WDCTL, 0xF0),   "CLR",          0, 1, 0 },
  { 0x01, 14, MAKECHILDID(WDCTL, 3),        "EN",           0, 1, 0 },
  { 0x01, 14, MAKECHILDID(WDCTL, 2),        "MODE",         0, 1, 0 },
  { 0x01, 14, MAKECHILDMASK(WDCTL, 0x03),   "INT",          0, 1, 0 },
  { 0x01, 14, MAKELASTCHILDID(WDCTL),       "",             0, 1, 0 },

  { 0x01, 15, MAKEITEMID(U0CSR, TRUE),      "U0CSR",        0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0CSR, 7),        "MODE",         0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0CSR, 6),        "RE",           0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0CSR, 5),        "SLAVE",        0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0CSR, 4),        "FE",           0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0CSR, 3),        "ERR",          0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0CSR, 2),        "RX_BYTE",      0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0CSR, 1),        "TX_BYTE",      0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0CSR, 0),        "ACTIVE",       0, 0, 0 },
  { 0x01, 15, MAKELASTCHILDID(U0CSR),       "",             0, 1, 0 },
  { 0x01, 15, MAKEITEMID(U0UCR, TRUE),      "U0UCR",        0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0UCR, 7),        "FLUSH",        0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0UCR, 6),        "FLOW",         0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0UCR, 5),        "D9",           0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0UCR, 4),        "BIT9",         0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0UCR, 3),        "PARITY",       0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0UCR, 2),        "SPB",          0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0UCR, 1),        "STOP",         0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0UCR, 0),        "START",        0, 1, 0 },
  { 0x01, 15, MAKELASTCHILDID(U0UCR),       "",             0, 1, 0 },
  { 0x01, 15, MAKEITEMID(U0GCR, TRUE),      "U0GCR",        0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0GCR, 7),        "CPOL",         0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0GCR, 6),        "CPHA",         0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U0GCR, 5),        "ORDER",        0, 1, 0 },
  { 0x01, 15, MAKECHILDMASK(U0GCR, 0x1F),   "BAUD_E",       0, 1, 0 },
  { 0x01, 15, MAKELASTCHILDID(U0GCR),       "",             0, 1, 0 },
  { 0x01, 15, MAKEITEMID(U0DBUF, FALSE),    "U0DBUF",       0, 1, 0 },
  { 0x01, 15, MAKEITEMID(U0BAUD, FALSE),    "U0BAUD",       0, 1, 0 },
  { 0x01, 15, MAKEITEMID(U1CSR, TRUE),      "U1CSR",        0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1CSR, 7),        "MODE",         0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1CSR, 6),        "RE",           0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1CSR, 5),        "SLAVE",        0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1CSR, 4),        "FE",           0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1CSR, 3),        "ERR",          0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1CSR, 2),        "RX_BYTE",      0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1CSR, 1),        "TX_BYTE",      0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1CSR, 0),        "ACTIVE",       0, 0, 0 },
  { 0x01, 15, MAKELASTCHILDID(U1CSR),       "",             0, 1, 0 },
  { 0x01, 15, MAKEITEMID(U1UCR, TRUE),      "U1UCR",        0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1UCR, 7),        "FLUSH",        0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1UCR, 6),        "FLOW",         0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1UCR, 5),        "D9",           0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1UCR, 4),        "BIT9",         0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1UCR, 3),        "PARITY",       0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1UCR, 2),        "SPB",          0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1UCR, 1),        "STOP",         0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1UCR, 0),        "START",        0, 1, 0 },
  { 0x01, 15, MAKELASTCHILDID(U1UCR),       "",             0, 1, 0 },
  { 0x01, 15, MAKEITEMID(U1GCR, TRUE),      "U1GCR",        0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1GCR, 7),        "CPOL",         0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1GCR, 6),        "CPHA",         0, 1, 0 },
  { 0x01, 15, MAKECHILDID(U1GCR, 5),        "ORDER",        0, 1, 0 },
  { 0x01, 15, MAKECHILDMASK(U1GCR, 0x1F),   "BAUD_E",       0, 1, 0 },
  { 0x01, 15, MAKELASTCHILDID(U1GCR),       "",             0, 1, 0 },
  { 0x01, 15, MAKEITEMID(U1DBUF, FALSE),    "U1DBUF",       0, 1, 0 },
  { 0x01, 15, MAKEITEMID(U1BAUD, FALSE),    "U1BAUD",       0, 1, 0 },
};


struct rGroup* GetRegisterGroups(enum ChipId id, I32* pnItems)
{
    if(id == UnknownChip)
         *pnItems = 2;
    else
        *pnItems = _countof(rGroups);

    return(rGroups);
}

struct rItem* GetRegisterItems(enum ChipId id, I32* pnItems)
{
    if(id & 0x10)
    {
        *pnItems = _countof(rItems_Usb);
        return(rItems_Usb);
    }

    if(id == UnknownChip)
        *pnItems = 2;
    else
        *pnItems = _countof(rItems);

    return(rItems);    
}