//
//  Values are 32 bit values layed out as follows:
//
//   3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1
//   1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
//  +-+-+-+-+-+---------------------+-------------------------------+
//  |S|R|C|N|r|    Facility         |               Code            |
//  +-+-+-+-+-+---------------------+-------------------------------+
//
//  where
//
//      S - Severity - indicates success/fail
//
//          0 - Success
//          1 - Fail (COERROR)
//
//      R - reserved portion of the facility code, corresponds to NT's
//              second severity bit.
//
//      C - reserved portion of the facility code, corresponds to NT's
//              C field.
//
//      N - reserved portion of the facility code. Used to indicate a
//              mapped NT status value.
//
//      r - reserved portion of the facility code. Reserved for internal
//              use. Used to indicate HRESULT values that are not status
//              values, but are instead message ids for display strings.
//
//      Facility - is the facility code
//
//      Code - is the facility's status code
//
//
// Define the facility codes
//
#define FACILITY_SMARTICE04              0x4


//
// Define the severity codes
//


//
// MessageId: SMARTICE04_E_NOTARGETVOLTAGE
//
// MessageText:
//
//  There is no target voltage present.
//
#define SMARTICE04_E_NOTARGETVOLTAGE     ((HRESULT)0x80040201L)

//
// MessageId: SMARTICE04_E_NOTARGET
//
// MessageText:
//
//  There is no target chip attached to the debug adapter.
//
#define SMARTICE04_E_NOTARGET            ((HRESULT)0x80040202L)

//
// MessageId: SMARTICE04_E_NOTINPGMMODE
//
// MessageText:
//
//  The debug adapter is not in the programming mode.
//
#define SMARTICE04_E_NOTINPGMMODE        ((HRESULT)0x80040203L)

//
// MessageId: SMARTICE04_E_ALREADYUSED
//
// MessageText:
//
//  The debug interface is already in use by another object.
//
#define SMARTICE04_E_ALREADYUSED         ((HRESULT)0x80040204L)

//
// MessageId: SMARTICE04_E_TARGETNOTHALTED
//
// MessageText:
//
//  Target device is not halted.
//
#define SMARTICE04_E_TARGETNOTHALTED     ((HRESULT)0x80040205L)

//
// MessageId: SMARTICE04_E_VERIFYFAILED
//
// MessageText:
//
//  Verify failed, unequal data.
//
#define SMARTICE04_E_VERIFYFAILED        ((HRESULT)0x80040206L)

//
// MessageId: SMARTICE04_E_COMMUNICATIONFAILURE
//
// MessageText:
//
//  Communication failure: Lost contact with the chip.
//
#define SMARTICE04_E_COMMUNICATIONFAILURE ((HRESULT)0x80040207L)

//
// MessageId: SMARTICE04_E_TARGETLOCKED
//
// MessageText:
//
//  The target device's debug-lock bit is set.
//
#define SMARTICE04_E_TARGETLOCKED        ((HRESULT)0x80040208L)

