#ifndef MISC_H
#define MISC_H

HRESULT HresultFromHidErrorCode(NTSTATUS stat) throw();
HRESULT HresultFromErrno(void) throw();
BSTR BSTRFromStringA(const char* pstr) throw();
void TrimA(char* psz);
HRESULT GetTypeInfoOfChipIdEnumeration(ISmartICE04* pDevice, ITypeInfo** ppTypeInfo);

#ifdef UNICODE
#define BSTRFromString  SysAllocString
#else
#define BSTRFromString  BSTRFRomStringA
#define Trim            TrimA
#endif

#ifdef _DEBUG
template<typename T> inline BOOL IsBadWritePtrAuto(T pt)
{
    return(::IsBadWritePtr(pt, sizeof(*pt)));
}

template<typename T> inline BOOL IsBadReadPtrAuto(T pt)
{
    return(::IsBadReadPtr(pt, sizeof(*pt)));
}
#else
#define IsBadWritePtrAuto(val)  (!(val))
#define IsBadReadPtrAuto(val)   (!(val))
#endif
#endif