#include "precomp.h"

HRESULT AskForFileName(HWND hWndParent, int idEdit, UINT idFilter, REFGUID client) throw()
{
    COMDLG_FILTERSPEC* pSpec = NULL;
    IFileDialog* pfd = NULL;
    IShellItem* pItem;
    OPENFILENAME ofn;
    HRESULT hr;
    TCHAR szFilter[128], szFileName[MAX_PATH * 2];
    LPTSTR pszTemp;
    unsigned x, idx, cnt = 0;

    GetDlgItemText(hWndParent, idEdit, szFileName, _countof(szFileName));

    if(FAILED(CoCreateInstance(CLSID_FileOpenDialog, NULL, CLSCTX_SERVER, IID_IFileOpenDialog, (void**)&pfd)))
    {
        ZeroMemory(&ofn, sizeof(ofn));
        ofn.lStructSize     = sizeof(ofn);
        ofn.hwndOwner       = hWndParent;
        ofn.hInstance       = g_hInst;
        ofn.lpstrFilter     = szFilter;
        ofn.nFilterIndex    = 1;
        ofn.lpstrFile       = szFileName;
        ofn.nMaxFile        = _countof(szFileName);
        ofn.Flags           = OFN_ENABLESIZING | OFN_EXPLORER | OFN_LONGNAMES | OFN_NOREADONLYRETURN | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST;

        LoadString(g_hInst, idFilter, szFilter, _countof(szFilter));

        for(pszTemp = szFilter; *pszTemp; ++pszTemp)
            if(*pszTemp == TEXT('|'))
                *pszTemp = TEXT('\0');

        if(!GetOpenFileName(&ofn))
            return((CommDlgExtendedError()) ? E_FAIL : S_FALSE);

        hr = S_OK;
    }
    else
    {
        pfd->SetClientGuid(client);

        if(LoadString(g_hInst, idFilter, szFilter, _countof(szFilter)))
        {
            for(x = 0; szFilter[x]; ++x)
                if(szFilter[x] == TEXT('|'))
                    ++cnt;

            if(cnt % 2)
                cnt = 0;
            else
                cnt /= 2;
        }

        if(NULL != (pSpec = ((cnt) ? (new (std::nothrow) COMDLG_FILTERSPEC[cnt]) : NULL)))
        {
            ZeroMemory(pSpec, sizeof(*pSpec) * (cnt));
            pSpec->pszName = pszTemp = szFilter;

            for(x = idx = 0; *pszTemp; ++pszTemp)
            {
                if(*pszTemp == TEXT('|'))
                {
                    *pszTemp = TEXT('\0');

                    if(idx < cnt)
                    {
                        if(++x % 2)
                        {
                            pSpec[x / 2].pszSpec = pszTemp + 1;
                            ++idx;
                        }
                        else
                        {
                            pSpec[x / 2].pszName = pszTemp + 1;
                        }
                    }
                }
            }

            ofn.nFilterIndex = 0;

            if(NULL == (ofn.lpstrFileTitle = PathFindFileName(szFileName)))
                ofn.lpstrFileTitle = szFileName;

            if(*ofn.lpstrFileTitle)
            {
                for(idx = 0; idx < cnt; ++idx)
                {
                    if(PathMatchSpec(ofn.lpstrFileTitle, pSpec[idx].pszSpec))
                    {
                        ofn.nFilterIndex = idx;
                        break;
                    }
                }
            }

            if(SUCCEEDED((hr = pfd->SetFileTypes(cnt, pSpec))))
            {
                if(SUCCEEDED((hr = pfd->SetFileTypeIndex(ofn.nFilterIndex + 1))))
                {
                    if(SUCCEEDED((hr = pfd->SetFileName(ofn.lpstrFileTitle))))
                    {
                        if(SUCCEEDED((hr = pfd->SetDefaultExtension(L""))))
                        {
                            if(SUCCEEDED((hr = pfd->Show(hWndParent))))
                            {
                                pItem = NULL;

                                if(SUCCEEDED((hr = pfd->GetResult(&pItem))))
                                {
                                    if(SUCCEEDED((hr = pItem->GetDisplayName(SIGDN_FILESYSPATH, &pszTemp))))
                                    {
                                        _tcsncpy(szFileName, pszTemp, _countof(szFileName) - 1);
                                        szFileName[_countof(szFileName) - 1] = TEXT('\0');
                                        CoTaskMemFree(pszTemp);
                                    }
                                    pItem->Release();
                                }
                            }
                            else
                            {
                                if(hr == HRESULT_FROM_WIN32(ERROR_CANCELLED))
                                    hr = S_FALSE;
                            }
                        }
                    }
                }
            }
            delete [] pSpec;
        }
        else
        {
            hr = E_FAIL;
        }
        pfd->Release();
    }

    if(SUCCEEDED(hr))
        SetDlgItemText(hWndParent, idEdit, szFileName);

    return(hr);
}
