#ifndef CSIUTIL_H
#define CSIUTIL_H

class CSiUtil
{
public:
    CSiUtil();
    virtual ~CSiUtil();

    virtual HRESULT Connect() = 0;
    virtual HRESULT Disconnect() = 0;
    virtual HRESULT Download(char* pDownloadFile, BOOL bDeviceErase);
    virtual HRESULT GetCodeMemory(BYTE* ptrMem, DWORD wStartAddress, unsigned int nLength);
    virtual HRESULT SetCodeMemory(BYTE* ptrMem, DWORD wStartAddress, unsigned int nLength);
    virtual HRESULT SetTargetGo();
};

class CSiUtilEC2 : public CSiUtil
{
public:
    CSiUtilEC2(int nCommPort);
    virtual ~CSiUtilEC2();

    virtual HRESULT Connect();
    virtual HRESULT Disconnect();

private:
    int m_nCommPort;
#ifdef _WIN64
    BYTE bPadding[4]; // C4820
#endif
};

class CSiUtilEC3 : public CSiUtil
{
public:
    CSiUtilEC3(const char* pSerNum);
    virtual ~CSiUtilEC3();

    virtual HRESULT Connect();
    virtual HRESULT Disconnect();

private:
    char* m_pSerNum;
};

#endif