#include "precomp.h"

WNDPROC CSmartICE04Dialog::m_wndpEdit = NULL;

CSmartICE04Dialog::CSmartICE04Dialog()
{
    m_wndpEdit = NULL;
}

CSmartICE04Dialog::~CSmartICE04Dialog()
{
}

LRESULT CALLBACK
CSmartICE04Dialog::EditSubclassProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    NCCALCSIZE_PARAMS*  pnccs;
    LRESULT             lResult;
    POINT               pt;
    RECT                rc;
    HWND                hWndBtn;

    lResult = CallWindowProc(m_wndpEdit, hWnd, uMsg, wParam, lParam);

    switch(uMsg)
    {
        case WM_NCCALCSIZE:
            if(wParam)
            {
                pnccs   = (NCCALCSIZE_PARAMS*)lParam;
                hWndBtn = GetWindow(hWnd, GW_HWNDNEXT);

                GetWindowRect(hWndBtn, &rc);

                rc.right  -= rc.left;
                rc.bottom  = pnccs->rgrc[0].bottom - pnccs->rgrc[0].top;

                pnccs->rgrc[0].right -= rc.right;

                rc.left    = pnccs->rgrc[0].right;
                rc.top     = pnccs->rgrc[0].top;

                MoveWindow(hWndBtn, rc.left, rc.top, rc.right, rc.bottom, TRUE);
            }
            break;
        case WM_NCHITTEST:
            if(lResult == HTNOWHERE)
            {
                GetWindowRect(GetWindow(hWnd, GW_HWNDNEXT), &rc);
                POINTSTOPOINT(pt, lParam);

                if(PtInRect(&rc, pt))
                    lResult = HTTRANSPARENT;
            }
            break;
        default:
            break;
    }

    return(lResult);
}

INT_PTR
CSmartICE04Dialog::OnWmInitDialog(HWND hWnd, WPARAM, LPARAM)
{
    const char* pSerNum;
    DWORD       dwDevices = 0, dwCurrent;
    TCHAR       szPort[32];
    HWND        hEdit;
    int         idx;

    SetWindowLongPtr(hWnd, GWL_EXSTYLE, (GetWindowLongPtr(hWnd, GWL_EXSTYLE) | WS_EX_APPWINDOW));

    hEdit = GetDlgItem(hWnd, IDC_IMAGE);
    m_wndpEdit = reinterpret_cast<WNDPROC>(SetWindowLongPtr(hEdit, GWLP_WNDPROC, reinterpret_cast<LONG_PTR>(EditSubclassProc)));
    SetWindowPos(hEdit, NULL, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOZORDER | SWP_FRAMECHANGED);

    ::USBDebugDevices(&dwDevices);

    for(dwCurrent = 0; dwCurrent < dwDevices; ++dwCurrent)
    {
        if(FAILED(::GetUSBDeviceSN(dwCurrent, &pSerNum)))
            continue;

        if(0 > (idx = static_cast<int>(SendDlgItemMessageA(hWnd, IDC_DEBUGADAPTER, CB_ADDSTRING, 0, reinterpret_cast<LPARAM>(pSerNum)))))
            continue;

        SendDlgItemMessage(hWnd, IDC_DEBUGADAPTER, CB_SETITEMDATA, static_cast<WPARAM>(idx), reinterpret_cast<LPARAM>(pSerNum));
    }

    lstrcpy(szPort, TEXT("COM"));

    for(dwCurrent = 1; dwCurrent <= 1024; ++dwCurrent)
    {
        _itot(static_cast<int>(dwCurrent), &szPort[3], 10);
        QueryDosDevice(szPort, NULL, 0);

        if(GetLastError() != ERROR_INSUFFICIENT_BUFFER)
            continue;

        if(0 > (idx = static_cast<int>(SendDlgItemMessage(hWnd, IDC_DEBUGADAPTER, CB_ADDSTRING, 0, reinterpret_cast<LPARAM>(szPort)))))
            continue;

        SendDlgItemMessage(hWnd, IDC_DEBUGADAPTER, CB_SETITEMDATA, static_cast<WPARAM>(idx), static_cast<LPARAM>(dwCurrent));
    }

    SendDlgItemMessage(hWnd, IDC_DEBUGADAPTER, CB_SETCURSEL, 0, 0);
    SetDlgItemInt(hWnd, IDC_EBID, 0x50, FALSE);
    return TRUE;
}

VOID
CSmartICE04Dialog::DoDownload(HWND hWndParent)
{
    const char* pSerNum;
    CSiUtil*    pSiUtil;
    CCursor     cursor(IDC_WAIT);
    char        szFileName[MAX_PATH * 2];
    int         idx;

    if(CB_ERR == (idx = static_cast<int>(SendDlgItemMessage(hWndParent, IDC_DEBUGADAPTER, CB_GETCURSEL, 0, 0))))
        return;

    pSerNum = reinterpret_cast<const char*>(SendDlgItemMessage(hWndParent, IDC_DEBUGADAPTER, CB_GETITEMDATA, static_cast<WPARAM>(idx), 0));
    GetDlgItemTextA(hWndParent, IDC_IMAGE, szFileName, _countof(szFileName));

    CSiUtilEC2 ec2(PtrToInt(pSerNum));
    CSiUtilEC3 ec3(pSerNum);

    if(IS_INTRESOURCE(pSerNum))
        pSiUtil = &ec2;
    else
        pSiUtil = &ec3;

    if(FAILED(pSiUtil->Download(szFileName, TRUE)))
        return;

    cursor.Refresh();
    GetDlgItemTextA(hWndParent, IDC_IMAGE, szFileName, _countof(szFileName));

    if(FAILED(pSiUtil->Download(szFileName, FALSE)))
        return;

    cursor.Refresh();
    WriteSerialNumber(pSiUtil);
    cursor.Refresh();
    pSiUtil->SetTargetGo();
}

VOID
CSmartICE04Dialog::WriteSerialNumber(CSiUtil* pSiUtil)
{
    SYSTEMTIME st;
    FILETIME ft;
    WCHAR sz[32];

    GetLocalTime(&st);
    SystemTimeToFileTime(&st, &ft);
    wsprintfW(sz, L"%08X-%08X", ft.dwHighDateTime, ft.dwLowDateTime);
    pSiUtil->SetCodeMemory(reinterpret_cast<BYTE*>(sz), 0x3C02, lstrlen(sz) * sizeof(sz[0]));
}

INT_PTR
CSmartICE04Dialog::OnWmCommand(HWND hWnd, WPARAM wParam, LPARAM)
{
    switch(LOWORD(wParam))
    {
        case IDC_BOOTLOADER_BROWSE:
        case IDC_IMAGE_BROWSE:
            AskForFileName(hWnd, LOWORD(wParam) - 1, IDS_FILTER, GUID_SmartICE04);
            return(TRUE);
        case IDOK:
            DoDownload(hWnd);
            return TRUE;
        case IDCANCEL:
            EndDialog(hWnd, 0);
            return TRUE;
        default:
            break;
    }

    return FALSE;
}

INT_PTR
CSmartICE04Dialog::DlgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
#pragma warning(push)
#pragma warning(disable: 4820)
    static const struct
    {
        UINT uMsg;
        INT_PTR (CSmartICE04Dialog::*pfn)(HWND hWnd, WPARAM wParam, LPARAM lParam);
    }
    map[] =
    {
        {   WM_COMMAND,     &OnWmCommand    }
    };
#pragma warning(pop)

    for(size_t x = 0; x < _countof(map); ++x)
        if(map[x].uMsg == uMsg)
            return (reinterpret_cast<CSmartICE04Dialog*>(GetWindowLongPtr(hWnd, DWLP_USER))->*map[x].pfn)(hWnd, wParam, lParam);

    if(uMsg == WM_INITDIALOG)
    {
        SetWindowLongPtr(hWnd, DWLP_USER, lParam);
        return(reinterpret_cast<CSmartICE04Dialog*>(lParam)->OnWmInitDialog(hWnd, wParam, lParam));
    }

    return FALSE;
}

int
CSmartICE04Dialog::DoModal(HWND hWndParent)
{
    CSmartICE04Dialog dlg;
    return(static_cast<int>(DialogBoxParam(g_hInst, MAKEINTRESOURCE(IDD_SMARTICE04), hWndParent, DlgProc, reinterpret_cast<LPARAM>(&dlg))));
}
