#ifndef SMARTICE04_H
#define SMARTICE04_H

#include <control.h>

// {FFE8C50A-7AE3-4F68-98E0-03679E7EF2A4}
DEFINE_GUID(IID_ISmartICE04Devices,
    0xFFE8C50A, 0x7AE3, 0x4F68, 0x98, 0xE0, 0x03, 0x67, 0x9E, 0x7E, 0xF2, 0xA4);

// {2BA82F65-D1A6-44A6-9BA3-1CE9686FD78B}
DEFINE_GUID(IID_ISmartICE04DevicesEvents,
    0x2BA82F65, 0xD1A6, 0x44A6, 0x9B, 0xA3, 0x1C, 0xE9, 0x68, 0x6F, 0xD7, 0x8B);

// {12D99D16-5433-4E7A-9CA6-837C6A117123}
DEFINE_GUID(DIID__DISmartICE04DevicesEvents,
    0x12D99D16, 0x5433, 0x4E7A, 0x9C, 0xA6, 0x83, 0x7C, 0x6A, 0x11, 0x71, 0x23);

// {AAD17982-BD7D-4EFC-8235-E471232296A6}
DEFINE_GUID(IID_ISmartICE04,
    0xAAD17982, 0xBD7D, 0x4EFC, 0x82, 0x35, 0xE4, 0x71, 0x23, 0x22, 0x96, 0xA6);

// {D9806DBD-5749-48CA-94F4-EEB7297CA947}
DEFINE_GUID(LIBID_SmartICE04Lib,
    0xD9806DBD, 0x5749, 0x48CA, 0x94, 0xF4, 0xEE, 0xB7, 0x29, 0x7C, 0xA9, 0x47);

// {CEAB1814-0840-4929-A0A3-2F8581240566}
DEFINE_GUID(CLSID_SmartICE04Devices,
    0xCEAB1814, 0x0840, 0x4929, 0xA0, 0xA3, 0x2F, 0x85, 0x81, 0x24, 0x05, 0x66);

// {BBA188C3-948A-4F3F-9E97-9EF79068006D}
DEFINE_GUID(CLSID_SmartICE04,
    0xBBA188C3, 0x948A, 0x4F3F, 0x9E, 0x97, 0x9E, 0xF7, 0x90, 0x68, 0x00, 0x6D);

// {B5D99E42-976D-4171-9C34-5369B65D8BB1}
DEFINE_GUID(IID_ISmartICE04Events,
    0xB5D99E42, 0x976D, 0x4171, 0x9C, 0x34, 0x53, 0x69, 0xB6, 0x5D, 0x8B, 0xB1);

// {5089D3CE-5E72-412E-BEBC-5BD6B39F2C12}
DEFINE_GUID(DIID__DISmartICE04Events,
    0x5089D3CE, 0x5E72, 0x412E, 0xBE, 0xBC, 0x5B, 0xD6, 0xB3, 0x9F, 0x2C, 0x12);

// {E1D20737-7D34-4868-A671-2033AAC3FDFE}
DEFINE_GUID(IID_ISmartICE04Progress,
    0xE1D20737, 0x7D34, 0x4868, 0xA6, 0x71, 0x20, 0x33, 0xAA, 0xC3, 0xFD, 0xFE);

// {F10F6F32-84B7-4A23-A399-6DFCA4E49869}
DEFINE_GUID(IID_ISmartICE04ProgressDialog,
    0xF10F6F32, 0x84B7, 0x4A23, 0xA3, 0x99, 0x6D, 0xFC, 0xA4, 0xE4, 0x98, 0x69);

// {84ABA153-4A94-42ac-A4B4-E9544BE6D928}
DEFINE_GUID(DIID_ISmartICE04ProgressDisp,
    0x84ABA153, 0x4A94, 0x42AC, 0xa4, 0xB4, 0xE9, 0x54, 0x4B, 0xE6, 0xD9, 0x28);

// {C057D364-71E8-45F3-B79E-3FFC0B4E2514}
DEFINE_GUID(CLSID_SmartICE04ProgressDialog,
    0xC057D364, 0x71E8, 0x45F3, 0xB7, 0x9E, 0x3F, 0xFC, 0x0B, 0x4E, 0x25, 0x14);

enum ChipId
{
    UnknownChip = 0x00,
    CC1110 = 0x01,
    CC1111 = 0x11,
    CC2430 = 0x85,
    CC2431 = 0x89,
    CC2510 = 0x81,
    CC2511 = 0x91,
    CC2530 = 0xA5,
    CC2531 = 0xB5,
    CC2533 = 0x95,
    CC2540 = 0x8D,
    CC2541 = 0x41,
    CC2543 = 0x43,
    CC2544 = 0x44,
    CC2545 = 0x45
};

enum DebugConfigFlags
{
    SoftPowerMode = 0x20,
    TimersOff = 0x08,
    DmaPause = 0x04,
    TimerSuspend = 0x02,
    SelFlashInfoPage = 0x01
};

enum DebugStatusFlags
{
    ChipEraseDone = 0x80,
    PconIdle = 0x40,
    CpuHalted = 0x20,
    PowerMode0 = 0x10,
    HaltStatus = 0x08,
    DebugLocked = 0x04,
    OscillatorStable = 0x02,
    StackOverflow = 0x01
};

enum MemorySegment
{
    segCode = 0,
    segData = 1,
    segXData = 2,
    segIData = 3
};

enum FileType
{
    fileAutoDetect = 0,
    fileBinary = 1,
    fileIntelHex = 2
};

#define MAKE_INSTRUCTION(len, b1, b2, b3)       (((len) << 24) | (b1) | ((b2) << 8) | ((b3) << 16))
#define MAKE_INSTRUCTION1(b)                    MAKE_INSTRUCTION(1, (b), 0, 0)
#define MAKE_INSTRUCTION2(b1, b2)               MAKE_INSTRUCTION(2, (b1), (b2), 0)
#define MAKE_INSTRUCTION3(b1, b2, b3)           MAKE_INSTRUCTION(3, (b1), (b2), (b3))

#undef  INTERFACE
#define INTERFACE ISmartICE04Devices
DECLARE_INTERFACE_IID_(ISmartICE04Devices, IDispatch, "FFE8C50A-7AE3-4F68-98E0-03679E7EF2A4")
{
    STDMETHOD(QueryInterface) (THIS_ REFIID riid, void** ppvObject)PURE;
    STDMETHOD_(ULONG, AddRef) (THIS)PURE;
    STDMETHOD_(ULONG, Release)(THIS)PURE;

    STDMETHOD(GetTypeInfoCount)(THIS_ UINT* pctinfo)PURE;
    STDMETHOD(GetTypeInfo)(THIS_ UINT iTInfo, LCID lcid, ITypeInfo** ppTInfo)PURE;
    STDMETHOD(GetIDsOfNames)(THIS_ REFIID riid, LPOLESTR* rgszNames, UINT cNames, LCID lcid, DISPID* rgDispId)PURE;
    STDMETHOD(Invoke)(THIS_ DISPID dispIdMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult, EXCEPINFO* pExcepInfo, UINT* puArgErr)PURE;

    STDMETHOD(get_Item)(THIS_ const VARIANT varIndex, VARIANT* pVal)PURE;
    STDMETHOD(get_Count)(THIS_ long* pVal)PURE;
    STDMETHOD(get_length)(THIS_ long* pVal)PURE;
    STDMETHOD(get__NewEnum)(THIS_ IUnknown** ppVal)PURE;
};

#undef  INTERFACE
#define INTERFACE ISmartICE04DevicesEvents
DECLARE_INTERFACE_IID_(ISmartICE04DevicesEvents, IUnknown, "2BA82F65-D1A6-44A6-9BA3-1CE9686FD78B")
{
    STDMETHOD(QueryInterface) (THIS_ REFIID riid, void** ppvObject)PURE;
    STDMETHOD_(ULONG, AddRef) (THIS)PURE;
    STDMETHOD_(ULONG, Release)(THIS)PURE;

    STDMETHOD(OnDeviceAttached)(THIS_ IDispatch* sender, IDispatch* device)PURE;
    STDMETHOD(OnDeviceDetached)(THIS_ IDispatch* sender, IDispatch* device)PURE;
};

#undef  INTERFACE
#define INTERFACE ISmartICE04
DECLARE_INTERFACE_IID_(ISmartICE04, IDispatch, "AAD17982-BD7D-4EFC-8235-E471232296A6")
{
    STDMETHOD(QueryInterface) (THIS_ REFIID riid, void** ppvObject)PURE;
    STDMETHOD_(ULONG, AddRef) (THIS)PURE;
    STDMETHOD_(ULONG, Release)(THIS)PURE;

    STDMETHOD(GetTypeInfoCount)(THIS_ UINT* pctinfo)PURE;
    STDMETHOD(GetTypeInfo)(THIS_ UINT iTInfo, LCID lcid, ITypeInfo** ppTInfo)PURE;
    STDMETHOD(GetIDsOfNames)(THIS_ REFIID riid, LPOLESTR* rgszNames, UINT cNames, LCID lcid, DISPID* rgDispId)PURE;
    STDMETHOD(Invoke)(THIS_ DISPID dispIdMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult, EXCEPINFO* pExcepInfo, UINT* puArgErr)PURE;

    STDMETHOD(get_Parent)(THIS_ IDispatch** ppParent)PURE;
    STDMETHOD(get_ProductId)(THIS_ long* PID)PURE;
    STDMETHOD(get_SerialNumber)(THIS_ BSTR* SerNum)PURE;
    STDMETHOD(get_Icon)(THIS_ IDispatch** Picture)PURE;
    STDMETHOD(get_SmallIcon)(THIS_ IDispatch** Picture)PURE;
    STDMETHOD(get_ChipId)(THIS_ enum ChipId* cid)PURE;
    STDMETHOD(get_ChipVersion)(THIS_ long* vers)PURE;
    STDMETHOD(get_TargetVoltage)(THIS_ long* targetVoltage)PURE;
    STDMETHOD(EnterDebugMode)(THIS_ VARIANT_BOOL enableDebug)PURE;
    STDMETHOD(get_IsInDebugMode)(THIS_ VARIANT_BOOL* isInDbgMode)PURE;
    STDMETHOD(get_DebugConfig)(THIS_ long* configFlags)PURE;
    STDMETHOD(put_DebugConfig)(THIS_ long configFlags)PURE;
    STDMETHOD(ChipErase)(THIS)PURE;
    STDMETHOD(Halt)(THIS)PURE;
    STDMETHOD(Resume)(THIS)PURE;
    STDMETHOD(ReadStatus)(THIS_ long* statusFlags)PURE;
    STDMETHOD(DebugInstr)(THIS_ long cmd, long* result)PURE;
    STDMETHOD(StepReplace)(THIS_ long cmd, long* result)PURE;
    STDMETHOD(StepInstr)(THIS_ long* result)PURE;
    STDMETHOD(SetHwBreakpoint)(THIS_ long brkpntNumber, VARIANT_BOOL enable, long address)PURE;
    STDMETHOD(GetPc)(THIS_ long* pc)PURE;
    STDMETHOD(ReadLockBits)(THIS_ long* lockbits)PURE;
    STDMETHOD(WriteLockBits)(THIS_ long lockbits)PURE;
    STDMETHOD(GetMemory)(THIS_ enum MemorySegment seg, long startAddress, long len, VARIANT* progressItf, SAFEARRAY** data)PURE;
    STDMETHOD(SetMemory)(THIS_ enum MemorySegment seg, long startAddress, SAFEARRAY** data, VARIANT_BOOL verify, VARIANT* progressItf)PURE;
    STDMETHOD(DownloadFile)(THIS_ BSTR filename, enum FileType ft, VARIANT_BOOL verify, VARIANT* progressItf)PURE;
    STDMETHOD(GetBm)(THIS_ long* bm)PURE;
};

#undef  INTERFACE
#define INTERFACE ISmartICE04Events
DECLARE_INTERFACE_IID_(ISmartICE04Events, IUnknown, "B5D99E42-976D-4171-9C34-5369B65D8BB1")
{
    STDMETHOD(QueryInterface) (THIS_ REFIID riid, void** ppvObject)PURE;
    STDMETHOD_(ULONG, AddRef) (THIS)PURE;
    STDMETHOD_(ULONG, Release)(THIS)PURE;

    STDMETHOD(OnTargetVoltageChanged)(THIS_ IDispatch* sender, VARIANT_BOOL volatgeDetected)PURE;
    STDMETHOD(OnTargetChanged)(THIS_ IDispatch* sender, enum ChipId chipId)PURE;
    STDMETHOD(OnDebugModeChanged)(THIS_ IDispatch* sender, VARIANT_BOOL isInDebgMode)PURE;
};

#undef  INTERFACE
#define INTERFACE ISmartICE04Progress
DECLARE_INTERFACE_IID_(ISmartICE04Progress, IUnknown, "E1D20737-7D34-4868-A671-2033AAC3FDFE")
{
    STDMETHOD(QueryInterface) (THIS_ REFIID riid, PVOID* ppvObj)PURE;
    STDMETHOD_(ULONG, AddRef) (THIS)PURE;
    STDMETHOD_(ULONG, Release)(THIS)PURE;

    STDMETHOD(Start)(THIS)PURE;
    STDMETHOD(Stop)(THIS)PURE;
    STDMETHOD(SetProgress)(THIS_ long lCompleted, long lTotal)PURE;
    STDMETHOD(get_Canceled)(THIS_ VARIANT_BOOL* pbCanceled)PURE;
};

#undef  INTERFACE
#define INTERFACE ISmartICE04ProgressDialog
DECLARE_INTERFACE_IID_(ISmartICE04ProgressDialog, IDispatch, "F10F6F32-84B7-4A23-A399-6DFCA4E49869")
{
    STDMETHOD(QueryInterface) (THIS_ REFIID riid, void** ppvObject)PURE;
    STDMETHOD_(ULONG, AddRef) (THIS)PURE;
    STDMETHOD_(ULONG, Release)(THIS)PURE;

    STDMETHOD(GetTypeInfoCount)(THIS_ UINT* pctinfo)PURE;
    STDMETHOD(GetTypeInfo)(THIS_ UINT iTInfo, LCID lcid, ITypeInfo** ppTInfo)PURE;
    STDMETHOD(GetIDsOfNames)(THIS_ REFIID riid, LPOLESTR* rgszNames, UINT cNames, LCID lcid, DISPID* rgDispId)PURE;
    STDMETHOD(Invoke)(THIS_ DISPID dispIdMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult, EXCEPINFO* pExcepInfo, UINT* puArgErr)PURE;

    STDMETHOD(get_Title)(THIS_ BSTR* Title)PURE;
    STDMETHOD(put_Title)(THIS_ BSTR Title)PURE;
    STDMETHOD(get_Line1)(THIS_ BSTR* line)PURE;
    STDMETHOD(put_Line1)(THIS_ BSTR line)PURE;
    STDMETHOD(get_Line2)(THIS_ BSTR* line)PURE;
    STDMETHOD(put_Line2)(THIS_ BSTR line)PURE;
    STDMETHOD(get_LCID)(THIS_ LCID* lcid)PURE;
    STDMETHOD(put_LCID)(THIS_ LCID lcid)PURE;
    STDMETHOD(Create)(THIS_ OAHWND hWndParent, IDispatch** ppProgress)PURE;
};

#define DISPID_SMARTICE04_LISTITEM                  0x00000000
#define DISPID_SMARTICE04_PRODUCTID                 0x00000002
#define DISPID_SMARTICE04_SERIALNUMBER              0x00000003
#define DISPID_SMARTICE04_ICON                      0x00000004
#define DISPID_SMARTICE04_SMALLICON                 0x00000005
#define DISPID_SMARTICE04_CHIPID                    0x00000006
#define DISPID_SMARTICE04_CHIPVERSION               0x00000007
#define DISPID_SMARTICE04_TARGETVOLTAGE             0x00000008
#define DISPID_SMARTICE04_ENTERDEBUGMODE            0x00000009
#define DISPID_SMARTICE04_ISINDEBUGMODE             0x0000000A
#define DISPID_SMARTICE04_DEBUGCONFIG               0x0000000B
#define DISPID_SMARTICE04_CHIPERASE                 0x0000000C
#define DISPID_SMARTICE04_HALT                      0x0000000D
#define DISPID_SMARTICE04_RESUME                    0x0000000E
#define DISPID_SMARTICE04_READSTATUS                0x0000000F
#define DISPID_SMARTICE04_DEBUGINSTR                0x00000010
#define DISPID_SMARTICE04_STEPREPLACE               0x00000011
#define DISPID_SMARTICE04_STEPINSTR                 0x00000012
#define DISPID_SMARTICE04_SETHWBREAKPOINT           0x00000013
#define DISPID_SMARTICE04_GETPC                     0x00000014
#define DISPID_SMARTICE04_READLOCKBITS              0x00000015
#define DISPID_SMARTICE04_WRITELOCKBITS             0x00000016
#define DISPID_SMARTICE04_GETMEMORY                 0x00000017
#define DISPID_SMARTICE04_SETMEMORY                 0x00000018
#define DISPID_SMARTICE04_DOWNLOADFILE              0x00000019
#define DISPID_SMARTICE04_START                     0x0000001A
#define DISPID_SMARTICE04_STOP                      0x0000001B
#define DISPID_SMARTICE04_SETPROGRESS               0x0000001C
#define DISPID_SMARTICE04_CANCELED                  0x0000001D
#define DISPID_SMARTICE04_TITLE                     0x0000001E
#define DISPID_SMARTICE04_LINE1                     0x0000001F
#define DISPID_SMARTICE04_LINE2                     0x00000020
#define DISPID_SMARTICE04_LCID                      0x00000021
#define DISPID_SMARTICE04_CREATE                    0x00000022
#define DISPID_SMARTICE04_GETBM                     0x00000023
#define DISPID_SMARTICE04_ONDEVICEATTACHED          0x00001001
#define DISPID_SMARTICE04_ONDEVICEDETACHED          0x00001002
#define DISPID_SMARTICE04_ONTARGETVOLTAGECHANGED    0x00001003
#define DISPID_SMARTICE04_ONTARGETCHANGED           0x00001004
#define DISPID_SMARTICE04_ONDEBUGMODECHANGED        0x00001005
#define DISPID_SMARTICE04_PARENT                    0xFFFFFCDD
#define DISPID_SMARTICE04_LISTCOUNT                 0xFFFFFDED
#define DISPID_SMARTICE04_COLLCOUNT                 0xFFFFFDEE
#define DISPID_SMARTICE04__NEWENUM                  0xFFFFFFFC

#endif
